#!/bin/bash

## ${1} = cur_year
## ${2} = info_dump_path

year=`kdialog --title "List Netjuke collection" --inputbox "Enter year to list all tracks for:" "${1}"`

echo -e "All available Artists from the year   "$year"   @ Netjuke\n \n " > ${2}

mysql -BN -e "SELECT DISTINCT netjuke_artists.name FROM netjuke_artists, netjuke_tracks WHERE netjuke_artists.id = netjuke_tracks.ar_id AND netjuke_tracks.year = '$year' Group BY netjuke_artists.name;" netjuke | gawk 'BEGIN { FS = "\t"; }; { print $1 }' >> ${2}