#!/bin/bash

## ${1} = cur_artist
## ${2} = cur_title
## ${3} = info_dump_path
## ${4} = cur_album


#############################################

kdicon="$theme_path../icons/charts.png"
action=`kdialog --miniicon "$kdicon" --combobox "Search or consult Charts?" "Search" "Consult"`
if [ "$action" = "Search" ]; then

   searchtype=`kdialog --miniicon "$kdicon" --radiolist "Select a Chart to view:" "byartist" "Search by Artist" "off" "bytitle" "Search by Title" "off" "byalbum" "Search by Album" "off" "bygenre" "Search by Genre" "off"`

   url_id=`kdialog --miniicon "$kdicon" --title "Search by Genre in Acclaimed Music" --inputbox "Enter Genre ID: "`


elif [ "$action" = "Consult" ]; then

   searchtype=`kdialog --miniicon "$kdicon" --radiolist "Select a Chart to view:" "year" "Annual Charts" "off" "artist100" "Top 100 Artists" "off" "album100" "Top 100 Albums" "off" "title100" "Top 100 Singles" "off"`


else

   exit

fi