#!/bin/bash

## ${1} = cur_artist
## ${2} = info_dump_path
## ${3} = cur_title

cur_artist=`echo ${1} | sed s/' '/'+'/g`
cur_title=`echo ${3} | sed s/' '/'+'/g`
hitspp="25"

xmatch=`kdialog --title "Search Gracenote" --yesno "Exact match of Artist and Title?"`
if [ $? = 0 ]; then
   xartist="&xa=on"
   xtitle="&xt=on"
   #xalbum="&xd=on"
else
   xartist=""
   xtitle=""
   #xalbum=""
fi

url="http://www.gracenote.com/music/search-adv.html?q=$xartist&qartist=$cur_artist&qdisc=$xtitle&qtrack=$cur_title&n=$hitspp&x=51&y=11"

lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=100 -tagsoup -nolist | sed '/ *Displaying Disc */,/ *\[cleardot.gif\] */!d' | sed '/ *Displaying Disc .*/a\ ' | sed 's/^   *//g' | head -n 30 | sed '0,1i\
\
Matched Albums  @  Gracenote\
' > ${2}
