#!/bin/bash

## ${1} = cur_artist
## ${2} = cur_title
## ${3} = info_dump_path

cd /home/share/data/resources/music/charts/
	search_str=`kdialog --title "Music Hit Charts Search" --inputbox "Enter text to search for:"`

	mysql -BN -e "SELECT points, weeks, position, song_title, artist_name, release_year, chart_id FROM ALL_CHARTS WHERE artist_name LIKE '%$search_str%' OR song_title LIKE '%$search_str%';" music_charts | gawk 'BEGIN { FS = "\t"; print " \nChart\tPos.\tWeeks\tPoints\t\tArtist / Title\t\t\t\tRelease Date"; print "---------\t-------\t-----------\t-----------\t\t--------------------\t\t\t\t----------------------\n " }; { print $7 "\t" $3 "\t" $2 "\t" $1 "\t\t" $5 } { print "\t\t\t\t\t    " $4 } { print "\t\t\t\t\t\t\t\t\t\t" $6 "\n " }' | sed 's/"//' | sed 's/"//' > /home/vdea/.superkaramba/info-str
