# configuration settings

# the resolution of your screen
resX = 1024
resY = 768

# the amount of blank space you have on the left and right of the bar
# these values are pretty good, but if you change them and bad things
# start happening, please tell me
spaceL = 32
spaceR = 32

# whether to use the icons in basePath+iconPath
# if you specify 1 then the above path is used before everything in
# themePaths (see below), or it will be used after everything in
# themePaths.
useMyIcons = 0

# display minimised windows in the bar; the only reason I can think
# of not having this on is that this effects performance slightly
# although if this makes that big a difference you probably shouldn't
# bother this this docker at all...
useMinWin = 1

# use a smooth animation to zoom the icons. this will use a lot of
# memory to achieve a reasonable performance, so use only if you're
# running with >256Mb. My machine (256Mb) can just about manage. zoomFrames
# specify the number of frames to zoom through
useSmoothZoom = 1
zoomFrames = 5

# this is the relative path to your icons from the path in which OSXDocker.py
# resides; please note that the artwork (such as the transparent background) is
# also in here. it's usually better to change themePaths (below). this _must_
# end with a "/"
iconPath = "Icons/"

# list of icon themes, in order of preference, change to point to wherever your
# fancy takes you... :D. this _must_ be a list (something within "[" and "]" )
# like the iconPath (above), these entries _must_ end with "/"
themePaths = [ "/home/genneth/files/Aqua/", "/usr/kde/3.1/share/icons/crystalsvg/", "/usr/share/icons/gentoo/" ]

# where the icon configuration file is, relative to OSXDocker.py
configurationFile = "Buttons.txt"
