import karamba

import string
import os
import commands
import time
import glob

class Pager:
	def __init__(self):
		self.pagerbackfile="Pics/Pager/Pager_back.png"
		self.pagerfile="Pics/Pager/Pager.png"
		self.PagerPos = 0
		
	def setPos(self,Pos):
		self.PagerPos=Pos
		
	def setIcon(self,Icon):
		pass
		
	def getOffset(self):
		pass
	
	def zoomApp(self, widget,Off):
		pass
	
	def getSizeApp(self):
		return 64
		
	def getSizeIcon(self):
		pass
		
	def resetApp(self, widget):
		pass

	def createApp(self, widget,y):
		Desktop = commands.getoutput('dcop kwin KWinInterface currentDesktop')
		if int(Desktop) == 1:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*64)+1,15,self.pagerbackfile)
		elif int(Desktop) == 2:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*64)+32+2,15,self.pagerbackfile)
		elif int(Desktop) == 3:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*64)+1,40,self.pagerbackfile)
		elif int(Desktop) == 4:
			self.pagerback=karamba.createImage(widget,(self.PagerPos*64)+32+2,40,self.pagerbackfile)
		self.pager=karamba.createImage(widget,(self.PagerPos*64),15,self.pagerfile)

	#This function is the one that let you change your virtual desktop	
	def clickApp(self,widget,x,y):
		if (x < ((self.PagerPos*64)+32)):
			if (y < 39):
				os.system('dcop kwin KWinInterface setCurrentDesktop 1') # this call to dcop change the desktop
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+1,15)
			else:
				os.system('dcop kwin KWinInterface setCurrentDesktop 3')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+1,40)
		else:
			if (y < 39):
				os.system('dcop kwin KWinInterface setCurrentDesktop 2')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+32+2,15)
			else:
				os.system('dcop kwin KWinInterface setCurrentDesktop 4')
				karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+32+2,40)

	#This function is used in the widget update and check that the desktop you
	#are in is the same displayed from the pager (if you change desktop via taskbar
	#the pager in the RoundBar will not be updated without this function

	def check(widget):
		Desktop = commands.getoutput('dcop kwin KWinInterface currentDesktop')
		if int(Desktop) == 1:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+1,15)
		elif int(Desktop) == 2:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+32+2,15)
		elif int(Desktop) == 3:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+1,40)
		elif int(Desktop) == 4:
			karamba.moveImage(widget,self.pagerback,(self.PagerPos*64)+32+2,40)

class Apps:
	def __init__(self):
		Icon = ""
		IconHandle = 0
		SizeIcon = 0
		SizeApp = 0
		Xpos = 0
		Ypos = 0
		Offset = 0
		Tooltip = ""
		Command = ""
		
	def setIcon(self, icon):
		self.Icon=icon
		
	def setSize(self, size):
		self.Offset = 16
		self.SizeIcon=size
		self.SizeApp=self.SizeIcon + self.Offset
		
	def getSizeApp(self):
		return (self.SizeApp)
	
	def getSizeIcon(self):
		return (self.SizeIcon)
		
	def getOffset(self):
		return(self.Offset)
		
	def setTooltip(self, tooltip):
		self.Tooltip=tooltip
		
	def setCommand(self, command):
		self.Command=command
		
	def setPos(self,pos):
		self.Xpos = (pos*self.SizeApp)+(self.Offset)
		
	def createApp(self, widget,y):
		self.IconHandle = karamba.createImage(widget,self.Xpos,y,self.Icon)
		#karamba.addImageTooltip(widget,self.IconHandle,self.Tooltip)
		karamba.createClickArea(widget,self.Xpos,y,self.SizeApp,self.SizeApp,self.Command)
		karamba.resizeImage(widget,self.IconHandle,self.SizeIcon,self.SizeIcon)
		self.Ypos = y
		
	def resetApp(self, widget):
		karamba.resizeImage(widget,self.IconHandle,self.SizeIcon,self.SizeIcon)
		karamba.moveImage(widget,self.IconHandle,self.Xpos,self.Ypos)
		
	def zoomApp(self, widget,Off):
		if (Off < (self.SizeApp/2)):
			karamba.resizeImage(widget,self.IconHandle,((self.SizeApp+self.Offset)+(Off-(self.SizeApp/2))),((self.SizeApp+self.Offset)+(Off-(self.SizeApp/2))))
			karamba.moveImage(widget, self.IconHandle,(self.Xpos-(Off/8)),self.Ypos)
		elif (Off >= (self.SizeApp/2)):
			karamba.resizeImage(widget,self.IconHandle,((self.SizeApp+self.Offset)-(Off-(self.SizeApp/2))),((self.SizeApp+self.Offset)-(Off-(self.SizeApp/2))))
			karamba.moveImage(widget,self.IconHandle,(self.Xpos-(Off/8)),self.Ypos)
			
	def clickApp(self, widget,x,y):
		height=karamba.getImageHeight(widget,self.IconHandle)
		width=karamba.getImageWidth(widget,self.IconHandle)
		i=0
		while(i<=360):
			karamba.rotateImage(widget,self.IconHandle,i)
			karamba.redrawWidget(widget)
			i+=30

def iconpath():
	if os.path.exists(os.path.normpath(os.path.expandvars("$HOME/.kde/share/config/kdeglobals"))):
		file = open(os.path.normpath(os.path.expandvars("$HOME/.kde/share/config/kdeglobals")),'r')
		kdePath = os.path.normpath(os.path.expandvars("$HOME/.kde/"))
	else:
		file = open(os.path.normpath(os.path.expandvars("$HOME/.kde3/share/config/kdeglobals")),'r')
		kdePath = os.path.normpath(os.path.expandvars("$HOME/.kde3/"))
	#we search the right icon theme	
	for line in file.readlines():
		if string.count(line,"Theme"):
			strPos = string.find(line,'=') + 1
			iconTheme= string.strip(line[strPos:-1])
	#check for the icon theme
	if os.path.exists(os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/64x64/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/64x64/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/48x48/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join(("$KDEDIR/share/icons/",iconTheme,"/48x48/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/128x128/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/128x128/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/64x64/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/64x64/apps"),'')))
	elif os.path.exists(os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/48x48/apps"),'')))):
		return os.path.normpath(os.path.expandvars(string.join((kdePath,"/share/icons/",iconTheme,"/48x48/apps"),'')))
	file.close()

def parse(lista):
	file = open(os.path.expandvars(os.path.normpath("$HOME/.roundbarrc")), 'r')
	i = 0
	PagerPos = 2
	iconPath = iconpath()
	for line in file.readlines():
		if string.count(line[0:2],'#'):
			pass
		elif string.count(line,"Pager"):
			strPos = string.find(line, '=') + 1
			PagerYes = int(string.strip(line[strPos:-1]))
		elif string.count(line,"PagerPos"):
			strPos = string.find(line, '=') + 1
			PagerPos = int(string.strip(line[strPos:-1]))
			print PagerPos
		elif string.count(line,"Clock"):
			strPos = string.find(line, '=') + 1
			ClockYes = int(string.strip(line[strPos:-1]))
		elif string.count(line,"ClockPos"):
			strPos = string.find(line, '=') + 1
			ClockPos = int(string.strip(line[strPos:-1]))
		elif (i == PagerPos):
			lista.append(0)
			lista[i] = Pager()
			lista[i].setPos(PagerPos)
			i+=1
		elif string.count(line, "Exec"):
			lista.append(0)
			lista[i] = Apps()
			strPos = string.find(line, '=') + 1
			#we set up the commands to execute on click
			Commands=(string.strip(line[strPos:-1]))
			firstArgPos = string.find(Commands," ")
			if firstArgPos > 0 :
				firstArg = Commands[:firstArgPos]
			else:
				firstArg = Commands
			#if it's not a dcop call it's better to launch the command with kstart, so we can continue
			#to use the RoundBar
			if (firstArg != "dcop"):
				lista[i].setCommand("kstart " +Commands)
				print Commands
			else: 
				print Commands
				lista[i].setCommand(Commands)
		elif string.count(line, "Icon"):
			strPos = string.find(line, '=') + 1
			#if in the conf file  the Icon tag contains a path that exist we use it
			if os.path.exists(string.strip(line[strPos:-1])):
				 lista[i].setIcon(string.strip(line[strPos:-1]))
			#else we use the standard icon of the theme, if exist
			elif os.path.exists(os.path.normpath(iconPath+'/'+string.strip(line[strPos:-1])+".png")):
				lista[i].setIcon(os.path.normpath(iconPath+'/'+string.strip(line[strPos:-1])+".png"))
			lista[i].setSize(48)
			lista[i].setPos(i)
			i+=1	
			
def createBar(widget,nPos):
	## this code detect your resolution it's a rip-off of the code on cleanbar, i hope i could use it
	xwinfo = os.system("which xwininfo")
	if ( xwinfo != ""):
		fp = os.popen("xwininfo -root -stats")
		output = fp.read()
		output = output.splitlines()
		for x in output:
			param = x.split()
			if(len(param) > 1):
				if (param[0].find("Width:") != -1):
					resX = int( param[1])
				if (param[0].find("Height:") != -1):
					resY = int( param[1])
	else :
		print("\n Can't detect your resolution we use the default res.\n")
		resX = 1024
		resY = 768
	##This code  create the bar
	karamba.createImage(widget, 0, 0, "Pics/head-left.png")
	for i in range(1,nPos):
		karamba.createImage(widget, (i*64)+12, 5, "Pics/middle.png")
	karamba.createImage(widget, (nPos*64)+12, 5, "Pics/head-right.png")
	##Now we center it on the screen
	TotalBarWidth = 76+((nPos-1)*64)+46
	TotalBarHeight = 100
	karamba.resizeWidget(widget,TotalBarWidth,TotalBarHeight)
	karamba.moveWidget(widget,(resX-TotalBarWidth)/2,(resY-TotalBarHeight))
	
def designApps(widget,Icon):
	i = 0
	for i in range(len(Icon)):
		Icon[i].createApp(widget,18)




init = 0
IconApps = []

def initialize(widget):
	global init
	global IconApps
	if init == 0:
		parse(IconApps)
		createBar(widget,len(IconApps))
		designApps(widget,IconApps)
		init = 1
		
def initWidget(widget):
	
	pass
	
def widgetUpdated(widget):
	initialize(widget)
	pass
	
def widgetClicked(widget,x,y,button):
	if x > IconApps[0].getOffset():
		Icon = x/IconApps[0].getSizeApp()
		IconApps[Icon].clickApp(widget,x,y)
	karamba.redrawWidget(widget)
	pass
	
def widgetMouseMoved(widget,x,y,button):
	if x > IconApps[0].getOffset():
		Icon = x/IconApps[0].getSizeApp()
		Offset = x%IconApps[0].getSizeApp()
		if Icon < len(IconApps):
			IconApps[Icon].zoomApp(widget,Offset)
		else:
			i = 0
			for i in range(len(IconApps)):
				IconApps[i].resetApp(widget)
	else:
		i = 0
		for i in range(len(IconApps)):
			IconApps[i].resetApp(widget)
	karamba.redrawWidget(widget)
	pass
