#***************************************************************************
#                              SuperKicker 
#                            -------------------
#   begin                : Mon Jan 26 2004
#   copyright            : (C) 2004 by Dmitry "Troydm" Geurkov
#   email                : dmitry_627@mail.ru
#***************************************************************************

#***************************************************************************
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#***************************************************************************
from Super import *

######### APP Bar class ########################################
class APPBar( Image ):
        
     def __init__(self,widget,x,y,w,h):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/app.png')
             self.st=Image(widget,self.x+20,self.y+10,48,48,'pic/appstart.png')
             self.ko=Image(widget,self.x+75,self.y+10,48,48,'pic/appkonqueror.png')
             self.ks=Image(widget,self.x+125,self.y+10,48,48,'pic/appkonsole.png')
             self.hp=Image(widget,self.x+180,self.y+10,48,48,'pic/apphelp.png')
        
     def create(self):
             pass
             Image.create(self)
             self.st.create()
             self.ko.create()
             self.ks.create()
             self.hp.create()
        
     def click(self,x,y):
             pass
             if self.st.clicked(x,y):
                 karamba.execute('dcop kicker kicker popupKMenu \'QPoint 20 220\'')
             if self.ko.clicked(x,y):
                 karamba.execute('konqueror')
             if self.ks.clicked(x,y):
                 karamba.execute('konsole')
             if self.hp.clicked(x,y):
                 karamba.execute('susehelp')
#################################################################
class TASKBar( Image ):
        
     def __init__(self,widget,x,y,w,h):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/task.png')
             self.pg=Image(widget,self.x+20,self.y+8,48,48,'pic/taskpager.png')
             self.pgs=Image(widget,self.x+20,self.y+8,20,18,'pic/taskpagersel.png')
             self.ti=[[],[],[],[]]
             self.tt=[[],[],[],[]]
             self.ts=TASKSensor(widget)
        
     def create(self):
             pass
             Image.create(self)
             self.pg.create()
             self.pgs.create()
             self.pager()
             self.createTasks()
             self.updateTasks(self.ts.getCurrentDesktop())
        
     def taskAdded(self,task):
             pass
             i=self.ts.addTask(task)
             wd=0
             if i>6: wd=((i-6)/2)+1
             wd=540/(3+wd)
             d=self.ts.getCurrentDesktop()
             self.taskadd(d,i,wd)
             self.taskrepaint(d,i+1)
             self.updateTasks(d)
        
     def taskRemoved(self,task):
             pass
             i=self.ts.removeTask(task)
             self.ti[i[0]][i[1]].delete()
             self.ti[i[0]].pop(i[1])
             self.tt[i[0]][i[1]].delete()
             self.tt[i[0]].pop(i[1])
             self.taskrepaint(i[0],self.ts.getNumberOfTasks(i[0]))
             self.updateTasks(i[0])
        
     def createTasks(self):
             pass
             for d in range(len(self.ts.t)):
                 tn=self.ts.getNumberOfTasks(d)
                 wd=0
                 if tn>6: wd=((tn-7)/2)+1
                 wd=510/(3+wd)
                 for i in range(tn): self.taskadd(d,i,wd)
        
     def taskadd(self,desktop,task,width):
             pass
             d=desktop
             wd=(task/2)*width
             hd=(task%2)*24
             self.ti[d].append(Image(self.wd,self.x+70+wd,self.y+9+hd,180,24,'pic/taskbar.png'))
             self.ti[d][task].create()
             self.ti[d][task].resize(width,24)
             self.ti[d][task].hide()
             self.tt[d].append(Text(self.wd,self.x+80+wd,self.y+11+hd,width-20,24,self.ts.t[d][task][0],15,0,0,0))
             self.tt[d][task].create()
             self.tt[d][task].hide()
        
     def taskrepaint(self,desktop,tasks):
             pass
             wd=0
             if tasks>6: wd=((tasks-7)/2)+1
             wd=510/(3+wd)
             for i in range(tasks):
                 self.ti[desktop][i].resize(wd,24)
                 self.ti[desktop][i].move(self.x+70+(i/2)*wd,self.y+9+(i%2)*24)
                 self.tt[desktop][i].resize(wd-20,24)
                 self.tt[desktop][i].move(self.x+80+(i/2)*wd,self.y+11+(i%2)*24)
        
     def taskshow(self,desktop):
             pass
             for i in range(len(self.ti[desktop])):
                 self.ti[desktop][i].show()
                 self.tt[desktop][i].show()
        
     def taskhide(self,desktop):
             pass
             for i in range(len(self.ti[desktop])):
                 self.ti[desktop][i].hide()
                 self.tt[desktop][i].hide()
        
     def activeTaskChanged(self,task):
             pass
             if task!=0:
                 pass
                 self.ts.updateTask(task)
             else:
                 self.ts.updateCurrentTasks()
             self.updateCurrentTasks()
        
     def updateTask(self,desktop,task):
             pass
             if self.ts.isMinimazed(desktop,task):
                 self.ti[desktop][task].hide()
             else:
                 self.ti[desktop][task].show()
             self.tt[desktop][task].show()
        
     def updateCurrentTasks(self):
             pass
             d=self.ts.getCurrentDesktop()
             self.updateTasks(d)
             h=range(4)
             h.pop(d)
             for i in range(len(h)):
                 self.taskhide(h[i])
        
     def updateTasks(self,desktop):
             pass
             for i in range(self.ts.getNumberOfTasks(desktop)):
                 if self.ts.isMinimazed(desktop,i):
                     self.ti[desktop][i].hide()
                 else:
                     self.ti[desktop][i].show()
                 self.tt[desktop][i].show()
        
     def click(self,x,y):
             pass
             if self.clicked(x,y):
                 if self.pg.clicked(x,y):
                     if self.pg.x<=x<=self.pg.x+24 :
                         if self.pg.y<=y<=self.pg.y+24 :
                             if self.ts.getCurrentDesktop()!=0:
                                 self.taskhide(self.ts.getCurrentDesktop())
                                 self.ts.setDesktop(0)
                                 self.pager()
                                 self.updateTasks(0)
                         else:
                             if self.ts.getCurrentDesktop()!=2:
                                 self.taskhide(self.ts.getCurrentDesktop())
                                 self.ts.setDesktop(2)
                                 self.pager()
                                 self.updateTasks(2)
                     else:
                         if self.pg.y<=y<=self.pg.y+24 :
                             if self.ts.getCurrentDesktop()!=1:
                                 self.taskhide(self.ts.getCurrentDesktop())
                                 self.ts.setDesktop(1)
                                 self.pager()
                                 self.updateTasks(1)
                         else:
                             if self.ts.getCurrentDesktop()!=3:
                                 self.taskhide(self.ts.getCurrentDesktop())
                                 self.ts.setDesktop(3)
                                 self.pager()
                                 self.updateTasks(3)
                 else:
                     desktop=self.ts.getCurrentDesktop()
                     for i in range(len(self.ti[desktop])):
                         if self.ti[desktop][i].clicked(x,y):
                             if self.ts.isMinimazed(desktop,i):
                                 self.ts.restore(desktop,i)
                                 self.updateTasks(desktop)
                             elif self.ts.isFocused(desktop,i):
                                 self.ts.minimaze(desktop,i)
                                 self.updateTasks(desktop)
                             else:
                                 self.ts.focus(desktop,i)
                             break
        
     def pager(self):
             if self.ts.d==0:self.pgs.move(self.pg.x,self.pg.y)
             elif self.ts.d==1:self.pgs.move(self.pg.x+24,self.pg.y)
             elif self.ts.d==2:self.pgs.move(self.pg.x,self.pg.y+24)
             else :self.pgs.move(self.pg.x+24,self.pg.y+24)
########### SysTray  #########################
class SYSTRAYBar( Image ):
        
     def __init__(self,widget,x,y,w,h):
             pass
             Image.__init__(self,widget,x,y,w,h,'pic/systray.png')
             self.st=SysTray(widget,self.x+25,self.y+10,100,50)
        
     def create(self):
             pass
             Image.create(self)
             self.st.create()
#################################################################
appbar=0
taskbar=0
systraybar=0

#this is called when your widget is initialized
def initWidget(widget):
    pass
    global appbar,taskbar,systraybar
    appbar=APPBar(widget,0,0,250,65)
    taskbar=TASKBar(widget,250,0,600,65)
    systraybar=SYSTRAYBar(widget,850,0,150,65)
    appbar.create()
    taskbar.create()
    systraybar.create()
    #setKicker(0)


#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
    pass
    #setKicker(1)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass
    global appbar,taskbar
    appbar.click(x,y)
    taskbar.click(x,y)


#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    pass

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass
    global taskbar
    taskbar.taskAdded(task)

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.
def taskRemoved(widget, task):
    pass
    global taskbar
    taskbar.taskRemoved(task)

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass
    global taskbar
    taskbar.activeTaskChanged(task)

# This will be printed when the widget loads.
print "Superkaramba GlassBar loaded"
