#this import statement allows access to the karamba functions
import karamba
import time

arrow_name="arrow_sec.png"
arrow_min_name="arrow_min.png"
arrow_hour_name="arrow_hour.png"
arrow_img=0;
bg_name="clock_bg_big2.png"
ww=200
wh=200
#this is called when you widget is initialized
def initWidget(widget):
    #bg image
    tmp=karamba.createImage(widget,0,0,bg_name)
    w=ww#karamba.getImageWidth(widget,tmp);
    h=wh#karamba.getImageHeight(widget,tmp);
    karamba.resizeImageSmooth(widget,tmp,w,h)
    karamba.moveImage(widget,tmp,(ww-w)/2,(wh-h)/2)
    karamba.redrawWidget(widget);
    print "init\n"

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    arrow_img=karamba.createImage(widget,0,0,arrow_name)
    arrow_min=karamba.createImage(widget,0,0,arrow_min_name)
    arrow_hour=karamba.createImage(widget,0,0,arrow_hour_name)
    now = time.localtime(time.time())
    sec=now[5];
    min=now[4];
    hour=now[3];
#    karamba.resizeImageSmooth(widget,arrow_img,ww,wh)
    karamba.rotateImage(widget,arrow_img,6*sec)
    karamba.rotateImage(widget,arrow_min,6*min)
    karamba.rotateImage(widget,arrow_hour,30*hour+min/2)

    w=karamba.getImageWidth(widget,arrow_img)
    h=karamba.getImageHeight(widget,arrow_img)
    karamba.moveImage(widget,arrow_img,(ww-w)/2,(wh-h)/2)
    #
    w=karamba.getImageWidth(widget,arrow_min)
    h=karamba.getImageHeight(widget,arrow_min)
    karamba.moveImage(widget,arrow_min,(ww-w)/2,(wh-h)/2)
    #
    w=karamba.getImageWidth(widget,arrow_hour)
    h=karamba.getImageHeight(widget,arrow_hour)
    karamba.moveImage(widget,arrow_hour,(ww-w)/2,(wh-h)/2)
    #
    karamba.redrawWidget(widget);
    #
    karamba.deleteImage(widget,arrow_img)
    karamba.deleteImage(widget,arrow_min)
    karamba.deleteImage(widget,arrow_hour)
    #print "updating....",w,"x",h,"\n"
    
def widgetClicked(widget, x, y, button):
    pass
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass


# This will be printed when the widget loads.
print "Loaded my python extension!"

