import karamba
import icon
from docklet import Docklet
import socket
import asyncore
import time
import karamba
from threading import *
import string

class EBDocker (asyncore.dispatcher, Docklet):
	def __init__ (self, widget, x, y, path):
		Docklet.__init__(self, widget, "EBDocker", x, y, path)
		self.thread = Thread(None, asyncore.loop)

		asyncore.dispatcher.__init__(self)
		self.create_socket(socket.AF_INET, socket.SOCK_STREAM)
		authcookie = file("/home/genneth/.everybuddy/authcookie", "rb")
		socketEncoded = authcookie.read(2)
		socketNumber = ord(socketEncoded[0]) * 256 + ord(socketEncoded[1])
		print socketNumber
		self.connect( ("localhost", socketNumber) )
		auth = authcookie.read(8)
		print str(ord(auth[0])) + " " + str(ord(auth[1]))
		sent = self.send(auth)
		print sent
		authcookie.close()
		self.buffer = ""

		self.thread.start()

		self.getAttention = 0

		self.noficationAgent = Thread(None, self.doNotification, None, (widget, 0) )
		self.noficationAgent.start()

	def handle_connect(self):
		print "Opened connection"

	def handle_close(self):
		print "Closed connection"

	def writable(self):
		return 0

	def handle_read(self):
		params = ord(self.recv(1))
		for i in range(params):
			bytes = ord(self.recv(1)) * 256 + ord(self.recv(1))
			data = self.recv(bytes)
			if data == "message_receive":
				self.getAttention = 1
				print "Got message!!"
			print data
		print "-----------------"

	def sendCommand(self, command):
		self.send(chr(len(command)))
		for param in command:
			length1, length2 = divmod(len(param), 256)
			self.send(chr(length1))
			self.send(chr(length2))
			self.send(param)
			print "sent " + param
		print "-----------------"

	def closeConnection(self):
		self.close()

	def click(self, widget, x, y, button):
		if 8 <= y <= 8+48:
			if button == 1:
				self.getAttention = 0
				self.sendCommand( ("message_hold", "0") )
				print "OK, OK!!! I got the message!"
			elif button == 2:
				self.sendCommand( ("message_hold", "1") )
				pass

	def doNotification(self, widget, dummy):
		while self.thread.isAlive():
			if self.getAttention:
				icon.bounceIcon(widget, self.appIcon)
			time.sleep(3.00)
		pass
