#!/usr/bin/perl

################################
##                            ##
## Stock Quotes Grabber v0.3  ##
## Author: Ding-Hou Lee       ##
## Email: DL105@columbia.edu  ##
## Adapted for SuperKaramba   ##
## by Dogfoot                 ##
##   a frightening hack       ##
##   apologies to the         ##
##   original author          ##
##   sqsk@jamison.org         ##
##   improvements welcome     ##
################################


# the directory where you put Stock Quotes Grabber
$prog_dir = "/path/to/stock_quotes";

# the directory where you store the quotes, should be prog_dir/working
$data_dir = "/path/to/stock_quotes/working/";

# put in the path of your lynx browser
$lynx_cmd = "/usr/bin/lynx -source";

##########
########## YOU SHOULDN'T HAVE TO EDIT PAST HERE
##########

# Mess with stuff below at your own risk
# url to the quote script

$quotes_url = "http://finance.yahoo.com/d/quotes.csv?";

# where your stocks symbols are stored.  You can just copy them from
# Yahoo! to this text file.
$symbol_file = "$prog_dir/symbols_to_poll.txt";

# array to convert month in name to month in number
$month2no{"Jan"} = "01";
$month2no{"Feb"} = "02";
$month2no{"Mar"} = "03";
$month2no{"Apr"} = "04";
$month2no{"May"} = "05";
$month2no{"Jun"} = "06";
$month2no{"Jul"} = "07";
$month2no{"Aug"} = "08";
$month2no{"Sep"} = "09";
$month2no{"Oct"} = "10";
$month2no{"Nov"} = "11";
$month2no{"Dec"} = "12";

$symbols = "";

open(FILE, "< $symbol_file") || die "Error opening the symbols file!";
while(<FILE>){

    chop($_);
    @fields = split(/[ ]+/, $_);
    foreach $field (@fields){
	$symbols .= $field;
	$symbols .= "+";
    }

}

chop($symbols);

# append the arguments to the quote url
#$quotes_url .= "s=$symbols&f=sl1d1t1c1ohgv&e=.csv";
$quotes_url .= "s=$symbols&f=sl1c1&e=.csv";

# Get the date to derive the filename
#$date = `date`;
#chop($date);

#@fields = split(/[ ]+/, $date);
#$day_of_week = $fields[0];
#$day_of_week =~ tr/[A-Z]/[a-z]/;

#$month = $month2no{$fields[1]};
#$day = $fields[2];

#$length = length($day);

# If day is represented in single digit, pre-pend it with a 0.
#if ($length != 2){
#    $day = "0".$day;
#}

#$year = $fields[5];

#$filename = $month;
#$filename .= $day;
#$filename .= "-";
#$filename .= "$year";
#$filename .= "-";
#$filename .= "$day_of_week";
#$filename .= ".csv";
$filename .= "stocks.txt";

# using lynx to retrieve the quote file and save it as a file.
system("$lynx_cmd \"$quotes_url\" > $data_dir$filename 2>/dev/null");

close(FILE);
exit 0;
