import os
import karamba
import string

init = 0
info_dump = []
display_lines = []
first_displayed_line = 0
last_row = 0
info_dump_path = ""
last_mod_time = 0
cur_mod_time = 1
counter = 0
bgImage = None
img_background = "../images/transparent.png"
skin = 'skin1'
#############################################################

def redisInfo(widget):
   global info_dump
   global first_displayed_line
   global display_lines
   global last_mod_time, counter
   global output, skin

   counter = counter + 1
   if (counter > 100):
      fp = open(info_dump_path,"w")
      fp.write("")
      fp.close()
      counter = 0
      last_mod_time = 0

   checkInfostr(widget)
   if (cur_mod_time != last_mod_time):
      last_mod_time = cur_mod_time
      counter = 0
      print "refresh"
      info_dump = []

      try:
         fp = open(info_dump_path, 'r')
         output = fp.readlines()
      except:
         output = ""

      i = 0
      for x in output:
         i=i+1
         if len(x)>120:
            for y in range(0, 120):
               if (x[y] == " "):
                  last_space = y

            if (last_space < 10):
               last_space = 120
            info_dump.append(str(x[0:last_space]))
            new_row = str(x[last_space +1:])
            if len(new_row)>120:
               new_row = new_row[0:120]
            info_dump.append(new_row)
            i=i+1
         else:
            info_dump.append(str(x))

      for i in range(90):
         text = display_lines[i]
         karamba.changeText(widget, text, "")

      for i in range(first_displayed_line, len(info_dump)):
         if i < (first_displayed_line + 90):
            text = display_lines[i-first_displayed_line]
            texttitle = info_dump[i]
            if len(texttitle) > 120:
               texttitle = texttitle[0:]

            karamba.changeText(widget, text, str(texttitle))
            if(skin == 'skin1'):
               karamba.changeTextColor(widget, text, 255, 255, 255)
               karamba.changeTextSize(widget, text, 13)
               karamba.changeTextShadow(widget, text, 1)
               karamba.changeTextFont(widget, text, "FrizQuadrata")
            # FrizQuadrata 12 pt. Orange
            elif(skin == 'skin2'):
               karamba.changeTextColor(widget, text, 255, 157, 70)
               karamba.changeTextSize(widget, text, 12)
               karamba.changeTextShadow(widget, text, 1)
               karamba.changeTextFont(widget, text, "FrizQuadrata")
            # FrizQuadrata 13 pt. Light Blue
            elif(skin == 'skin3'):
               karamba.changeTextColor(widget, text, 193, 234, 255)
               karamba.changeTextSize(widget, text, 13)
               karamba.changeTextShadow(widget, text, 1)
               karamba.changeTextFont(widget, text, "FrizQuadrata")
            # Courier [ibm] 10 pt. Navy Blue
            elif(skin == 'skin4'):
               karamba.changeTextColor(widget, text, 16, 32, 102)
               karamba.changeTextSize(widget, text, 10)
               karamba.changeTextShadow(widget, text, 0)
               karamba.changeTextFont(widget, text, "Courier [ibm]")
            # Courier [ibm] 10 pt. Orange
            elif(skin == 'skin5'):
               karamba.changeTextColor(widget, text, 255, 138, 66)
               karamba.changeTextSize(widget, text, 10)
               karamba.changeTextShadow(widget, text, 0)
               karamba.changeTextFont(widget, text, "Courier [ibm]")
            # Courier [ibm] 10 pt. White
            elif(skin == 'skin6'):
               karamba.changeTextColor(widget, text, 255, 255, 255)
               karamba.changeTextSize(widget, text, 10)
               karamba.changeTextShadow(widget, text, 0)
               karamba.changeTextFont(widget, text, "Courier [ibm]")
            # Courier [ibm] 11 pt. Light Blue
            elif(skin == 'skin7'):
               karamba.changeTextColor(widget, text, 193, 234, 255)
               karamba.changeTextSize(widget, text, 11)
               karamba.changeTextShadow(widget, text, 0)
               karamba.changeTextFont(widget, text, "Courier [ibm]")
            else:
               karamba.changeTextColor(widget, text, 255, 255, 255)
               karamba.changeTextSize(widget, text, 10)
               karamba.changeTextShadow(widget, text, 0)
               karamba.changeTextFont(widget, text, "Courier [ibm]")
      karamba.redrawWidget(widget)


def initWidget(widget):

   global clear_btn, open_btn, theme_path, info_dump_path

   theme_path = karamba.getThemePath(widget)
   test_path = karamba.readConfigEntry(widget, 'theme_path')
   if test_path == None:
      karamba.writeConfigEntry(widget, 'theme_path', theme_path)
   else:
      theme_path = karamba.readConfigEntry(widget, 'theme_path')

   info_dump_path = theme_path + "../data/info_dump"

   ch_skin(widget)
   karamba.addMenuConfigOption(widget, "skin", "Skin Selector")
   karamba.setMenuConfigOption(widget, "skin", 0)

   open_btn = karamba.createImage(widget, 105, 5, "../icons/open.png")
   karamba.attachClickArea(widget, open_btn)
   karamba.addImageTooltip(widget, open_btn,"Open in Text Editor")

   clear_btn = karamba.createImage(widget, 130, 5, "../icons/clear.png")
   karamba.attachClickArea(widget, clear_btn)
   karamba.addImageTooltip(widget, clear_btn,"Clear buffer")

   mod_header = karamba.createText(widget, 5, 5, 100, 15, "Info Terminal")
   karamba.changeTextColor(widget, mod_header, 255, 255, 255)
   karamba.changeTextSize(widget, mod_header, 11)
   karamba.changeTextShadow(widget, mod_header, 0)
   karamba.changeTextFont(widget, mod_header, "Courier [ibm]")

########################################################

def widgetUpdated(widget):
   global init
   global first_displayed_line
   global last_row
   global info_dump
   global last_mod_time
   global counter

   #counter = counter + 1

   if init == 0:
      init = 1

      fp = open(info_dump_path, 'r')
      output = fp.readlines()

      i = 0
      for x in output:
         i=i+1
         info_dump.append(str(x))

      for i in range(len(info_dump)):
         if i < 90:
            texttitle = info_dump[i]
            if len(texttitle) > 120:
               texttitle = texttitle[0:120]

            text = karamba.createText(widget, 14, (i*13)+30, 0, 0, str(texttitle))
            display_lines.append(text)

      if len(display_lines) < 90:
         lower = len(display_lines)
         for x in range(lower, 90):
            text = karamba.createText(widget, 14, (x*13)+30, 0, 0, str(""))
            display_lines.append(text)
         karamba.redrawWidget(widget)

   redisInfo(widget)


def widgetClicked(widget, x, y, button):
   global last_row
   global first_displayed_line
   global info_dump
   global last_mod_time, counter

   if (button == 4):
      first_displayed_line = first_displayed_line - 5
      last_mod_time = 0
      counter = 0
      if first_displayed_line < 0:
         first_displayed_line = 0
      redisInfo(widget)

   if (button == 5):
      first_displayed_line = first_displayed_line + 5
      last_mod_time = 0
      counter = 0
      if first_displayed_line > len(info_dump):
         first_displayed_line = len(info_dump)-1
      redisInfo(widget)

   if (button == 1):
      first_displayed_line = 0
      last_mod_time = 0
      counter = 0
      if first_displayed_line < 0:
         first_displayed_line = 0
      redisInfo(widget)

def checkInfostr(widget):

   global cur_mod_time, last_mod_time

   cur_mod_time = os.path.getmtime(info_dump_path)
   if cur_mod_time != last_mod_time:
      last_mod_time = 0

def menuOptionChanged(widget, key, value):
   global bgImage, skin_pid
   bgcommand = ["kdialog", "--title", "Skin Selector", "--radiolist", "Please select a skin to use:", "skin1", "FrizQuadrata 13 pt. White","off","skin2", "FrizQuadrata 12 pt. Orange","off","skin3","FrizQuadrata 13 pt. Light Blue","off","skin4","Courier [ibm] 10 pt. Navy Blue","off","skin5","Courier [ibm] 10 pt. Orange","off","skin6","Courier [ibm] 10 pt. White","off","skin7","Courier [ibm] 11 pt. Light Blue","off"]
   karamba.setMenuConfigOption(widget, "skin", 0)
   if key == 'skin':
      skin_pid = karamba.executeInteractive(widget, bgcommand)

def commandOutput(widget, pid, output):
   global skin_pid, last_mod_time
   output = output.replace('\n','')
   if (skin_pid == pid):
      karamba.writeConfigEntry(widget, 'skin', output)
      ch_skin(widget)
      last_mod_time = 0
      redisInfo(widget)


def ch_skin(widget):
   global bgImage, skin
   skin = karamba.readConfigEntry(widget, 'skin')
   if (bgImage != None):
      karamba.deleteImage(widget, bgImage)

   if (skin == 'skin1'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin2'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin3'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin4'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin5'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin6'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   elif(skin == 'skin7'):
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)
   else:
      bgImage = karamba.createBackgroundImage(widget, 0, 0, img_background)

   karamba.redrawWidgetBackground(widget)
   karamba.redrawWidget(widget)

def meterClicked(widget, meter, button):

   if (meter == open_btn) and (button == 1):
      os.system('kwrite ' + info_dump_path)

   if (meter == clear_btn) and (button == 1):
      fp = open(info_dump_path,"w")
      fp.write("")
      fp.close()
      last_mod_time = 0
      redisInfo(widget)
