#!/bin/bash
#
# ${1}   -  info_dump_path
## TV Gids Online:

kdicon='../icons/browser.png'
site_root="http://www.tvgids.nl/"
choice1=`kdialog --miniicon $kdicon --caption "TV Gids Online" --radiolist "Kies een optie:" "nu_straks" "Nu & Straks" "on" "series" "Overzicht Series" "off" "zoek_s" "Snel zoeken op trefwoord" "off" "zoek+" "Gespecificeert zoeken" "off"`

if [ "$choice1" = "nu_straks" ]; then
   action="nustraks.php"
   url=$site_root$action

#	lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=270 -tagsoup -nolist | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */\t/g' | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/\t/g' | sed 's/  *[0-9]\{2\}\:/\t&/g' | sed 's/   */ /g' | sed '0,45d' | sed '/ *Nix */,/EOF/d' | sed '0,1i\		TV Gids Online @ (www.tvgids.nl)\
#\
#NU							STRAKS' | sed '/^ *Alle zenders */,/\.gif\]/d' | sed 's/\t\t/\t/g' | sed 's/^  *//g' | sed '/^Nickelodeon */d' > ${1}

   lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=260 -tagsoup -nolist | tail -n 29 | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */\t/g' | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/\t/g' | sed '/ *Nix */,/EOF/d' | sed 's/^  *//g' | sed '0,1i\		TV Gids Online @ (www.tvgids.nl)\
\
NU					STRAKS' | sed '/^ *Alle zenders */,/\.gif\]/d' | sed '/^Nickelodeon */d' | sed 's/\t  */\t/g' | sed 's/ [0-9]\{2\}\:/\t&/g' | sed 's/\t\t*/\t/g' | sed 's/\t /\t/g' > ${1}

elif [ "$choice1" = "series" ]; then
   action="serie_ned.html"
   url=$site_root$action

   lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=350 -tagsoup -nolist | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */\t/g' | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/\t/g' | sed 's/\t\t*/\t/g' | sed 's/\t /\t/g' | sed '0,/ *i \=/d' > ${1}

elif [ "$choice1" = "zoek_s" ]; then
   action="zoekprogramma.php"
   station="0"
   genre=""
   interval="0"
   timeslot="0"
   trefwoord=`kdialog --title "TV Gids Online" --inputbox "Zoeken naar:" "Titel+of+trefwoord"`
   trefwoord=`echo $trefwoord | sed s/' '/'+'/g`
   url_args="?trefwoord=$trefwoord&x=0&y=0&station=$station&genre=$genre&interval=$interval&timeslot=$timeslot"
   url=$site_root$action$url_args

   lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=220 -tagsoup -nolist | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */ /g' | sed 's/ *Waarschuw mij via SMS voor aanvang proramma \= */ /g' | sed '0,45d' | sed '/ *Nix */,/EOF/d'  | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/ /g' | sed 's/^   *//g' | sed '/^Alle zenders */,/\.gif\]/d' | sed 's/  *[0-9]\{2\}\:/\t&/g' > ${1}

elif [ "$choice1" = "zoek+" ]; then
   action="zoekprogramma.php"
   station=`kdialog --miniicon $kdicon --caption "TV Gids Online" --radiolist "Kies een kanaal:" "0" "Alle zenders" "on" "1" "Nederland 1" "off" "2" "Nederland 2" "off" "3" "Nederland 3" "off" "4" "RTL 4" "off" "31" "RTL 5" "off" "37" "Net 5" "off" "36" "SBS 6" "off" "46" "Yorin" "off" "34" "Veronica" "off" "89" "Nickelodeon" "off" "5" "VRT TV1" "off" "6" "KETNET/Canvas" "off" "101" "Nederlandstalig" "off" "103" "Engelstalig" "off" "104" "Duitstalig" "off" "105" "Franstalig" "off" "106" "Overige zenders" "off"`
   genre=`kdialog --miniicon $kdicon --caption "TV Gids Online" --radiolist "Kies een genre:" "empty" "All Genres" "on" "film" "Film" "on" "amusement" "Amusement" "off" "nieuws" "Nieuws/actualiteiten" "off" "informatief" "Informatief" "off" "comedy" "Comedy" "off" "serie" "Serie/soap" "off" "misdaad" "Misdaad" "off" "sport" "Sport" "off" "muziek" "Muziek" "off" "documentaire" "Documentaire" "off" "erotiek" "Erotiek" "off" "kunst" "Kunst/Cultuur" "off" "wetenschap" "Wetenschap" "off" "jeugd" "Jeugd" "off" "natuur" "Natuur" "off" "animatie" "Animatie" "off" "religieus" "Religieus" "off" "theater" "Theater" "off" "overige" "Overige" "off"`
   if [ "$genre" = "empty" ]; then
      genre=""
   else
      genre=`echo $genre`
   fi
   interval=`kdialog --miniicon $kdicon --caption "TV Gids Online" --radiolist "Kies dag:" "10" "Gisteren" "off" "0" "Vandaag" "on" "1" "Morgen" "off" "2" "Overmorgen" "off"`
   if [ "$interval" = "10" ]; then
      interval="-1"
   else
      interval=`echo $interval`
   fi
   timeslot=`kdialog --miniicon $kdicon --caption "TV Gids Online" --radiolist "Kies een tijd:" "0" "Hele dag" "on" "1" "Nacht" "off" "2" "Ochtend" "off" "3" "Middag" "off" "4" "Avond" "off"`
   trefwoord=`kdialog --title "TV Gids Online" --inputbox "Zoeken naar:" "Titel+of+trefwoord"`
   trefwoord=`echo $trefwoord | sed s/' '/'+'/g`
   url_args="?trefwoord=$trefwoord&x=0&y=0&station=$station&genre=$genre&interval=$interval&timeslot=$timeslot"
   url=$site_root$action$url_args

   lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=220 -tagsoup -nolist | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */ /g' | sed 's/ *Waarschuw mij via SMS voor aanvang proramma \= */ /g' | sed '0,45d' | sed '/ *Nix */,/EOF/d'  | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/ /g' | sed 's/^   *//g' | sed '/^Alle zenders */,/\.gif\]/d' | sed 's/  *[0-9]\{2\}\:/\t&/g' > ${1}

else

   exit

fi

#echo -e "\n$url_args" >> ${1}

#lynx $url -dump -nolog -nopause -noprint -nostatus -raw -hiddenlinks=ignore -width=220 -tagsoup -nolist | sed 's/ *voeg toe aan je persoonlijke Tv Gids */\t/g' | sed 's/ *Waarschuw mij via SMS voor aanvang programma */ /g' | sed 's/ *Waarschuw mij via SMS voor aanvang proramma \= */ /g' | sed '0,45d' | sed '/ *Nix */,/EOF/d'  | sed 's/ *Gewijzigd en\/of aangevulde programmagegevens*/ /g' | sed 's/^   *//g' | sed '/^Alle zenders */,/\.gif\]/d' | sed 's/  *[0-9]\{2\}\:/\t&/g' > ${1}
