#!/bin/bash

## ${1} = cal_path
## ${2} = cal_export_type
## ${3} = info_dump_path
##---------------------------
## Calendar Export format
## "Short"  -->  summarized list of appointments and events (default)
## "Text"   -->   simple list of appointments and events (requires more display-lines per entry)

########################################################

getdays=`kdialog --title "Kalendar" --inputbox "Enter the number of days from now to display:"`

if [ "$getdays" != "" ]; then
   konsolekalendar --view --show-next $getdays --export-type "${2}" --file "$1" > ${3}
else
   exit
fi