#!/bin/bash

## ${1} = cur_artist
## ${2} = info_dump_path

search_str=`kdialog --title "Search Artists in Veronica Top40" --inputbox "Enter Artist to search for: " "${1}"`

search_str=`echo $search_str | sed s/' '/'+'/g`

url="http://www.walravens.info/overzicht.php?artiest=$search_str&l=1&order=titel&ad=DESC"

echo -e "Source: Veronica's Top40  @  http://www.walravens.info" > ${2}
curl $url | html2text -width 100 -nobs | sed s/'_'/' '/g | sed '/progress*/d' | sed '/.   .   l   o   a   d   i   n   g/d' | sed '/Een moment geduld a\.u\.b\./d' | sed '/Bezig met het verzamelen van de juiste hits/d' | sed '/JAAR/a\ ' | sed '/ARTIEST/i\ ' >> ${2}
