#!/bin/bash
#
#  ${1} =  media_root
#  ${2} =  id3_src

if xmmsctrl running; then

   isstreaming="`xmmsctrl cur | cut -d'/' -f1`"

   if [ "$isstreaming" = "http:" ]; then
      cur_track_url="${1}`xmmsctrl cur | cut -d'/' -f5-`"
   else
      cur_track_url=`xmmsctrl cur`
   fi

   track_format=`xmmsctrl cur | tail -c 4`

   if [ "$track_format" = "mp3" ]; then
      #echo `id3info $cur_track_url | grep "=== TPE1" | sed 's/^.*: //g'`   #ARTIST
      #echo `id3info $cur_track_url | grep "=== TIT2" | sed 's/^.*: //g'`   #TITLE
      #echo `id3info $cur_track_url | grep "=== TALB" | sed 's/^.*: //g'`   #ALBUM
      echo `id3info "$cur_track_url" | grep "=== TCON" | sed 's/^.*: //g'`   #GENRE
      #echo `id3info $cur_track_url | grep "=== TYER" | sed 's/^.*: //g'`   #YEAR
         #echo `id3info $cur_track_url | grep "(Track Comments)" | sed 's/^.*: //g'`     #TITLE
   else
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ARTIST=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "TITLE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ALBUM=" | cut -d'=' -f2`
      echo `ogginfo "$cur_track_url" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "GENRE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "DATE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "COMMENTS=" | cut -d'=' -f2`
   fi

else

   exit

fi