#!/bin/bash
#
#  ${1} =  media_root
#  ${2} =  id3_src

if xmmsctrl running; then

   isstreaming="`xmmsctrl cur | cut -d'/' -f1`"

   if [ "$isstreaming" = "http:" ]; then
      cur_track_url="${1}`xmmsctrl cur | cut -d'/' -f5-`"
   else
      cur_track_url=`xmmsctrl cur`
   fi

   track_format=`xmmsctrl cur | tail -c 4`

   if [ "$track_format" = "mp3" ]; then
      #echo `id3 -lR $cur_track_url | grep "Artist:" | cut -d':' -f2`
      echo `id3 -lR "$cur_track_url" | grep "Title:" | cut -d':' -f2`
      #echo `id3 -lR $cur_track_url | grep "Track" | cut -d':' -f2`
      #echo `id3 -lR $cur_track_url | grep "Genre:" | cut -d':' -f2`
      #echo `id3 -lR $cur_track_url | grep "Year:" | cut -d':' -f2`
      #echo `id3 -lR $cur_track_url | grep "Comment:" | cut -d':' -f2`
   else
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ARTIST=" | cut -d'=' -f2`
      echo `ogginfo "$cur_track_url" | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "TITLE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "ALBUM=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "GENRE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "DATE=" | cut -d'=' -f2`
      #echo `ogginfo $cur_track_url | grep -A6 "TITLE=" | cut -d'=' -f1-2 | grep -A0 "COMMENTS=" | cut -d'=' -f2`
   fi

else

   exit

fi

