#this import statement allows access to the karamba functions
import karamba


images= [0,0,0,0,0,0,0,0]
imagesBig = [0,0,0,0,0,0,0,0]
imageFiles=[
    "pics/Tux_Terminal-64x64.png",
    "pics/web-64x64.png",
    "pics/Tux_Mail-64x64.png",
    "pics/home-64x64.png",
    "pics/chat-64x64.png",
    "pics/diagnostic-64x64.png",
    "pics/preferences-64x64.png",
    "pics/Tux_Sherlock-64x64.png"
    ]
imageFilesBig=[
    "pics/Tux_Terminal-96x96.png",
    "pics/web-96x96.png",
    "pics/Tux_Mail-96x96.png",
    "pics/home-96x96.png",
    "pics/chat-96x96.png",
    "pics/diagnostic-96x96.png",
    "pics/preferences-96x96.png",
    "pics/Tux_Sherlock-96x96.png"
    ]
pointerImageFile = "pics/pointer.png"
barimageFile = "pics/osxbarback.png"
barimage = 0
barimageBigFile = "pics/osxbarbackBig.png"
barimageBig = 0
init = 0
reset = 0
currZoomedPic = 0

def initWidget(widget):
    #buggy in current version
    pass

def widgetUpdated(widget):
    global images
    global imagesBig
    global imageFiles
    global imageFilesBig
    global barimage
    global barimageFile
    global barimageBig
    global barimageBigFile
    global init
    if init == 0:
        barimage = karamba.createImage(widget, 60, 62, barimageFile)
        barimageBig = karamba.createImage(widget, 6, 150, barimageBigFile)

        for i in range(8):
            images[i] = karamba.createImage(widget, (i*65)+35+60, 72, imageFiles[i])
            imagesBig[i] = karamba.createImage(widget, (i*65)+35+60, 150, imageFilesBig[i])
            karamba.redrawWidget(widget)
            reset = 1
        init = 1

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves

    #NOTE:  I'm blatently ignoring my own warning ^^^ haha

    global images
    global imagesBig
    global imageFiles
    global imageFilesBig
    global barimage
    global barimageFile
    global barimageBig
    global barimageBigFile
    global init
    global currZoomedPic
    global reset

    if init == 0:
        barimage = karamba.createImage(widget, 60, 62, barimageFile)
        barimageBig = karamba.createImage(widget, 6, 150, barimageBigFile)
        for i in range(8):
            images[i] = karamba.createImage(widget, (i*65)+35+60, 72, imageFiles[i])
            imagesBig[i] = karamba.createImage(widget, (i*65)+35+60, 150, imageFilesBig[i])
            karamba.redrawWidget(widget)
            reset = 1
        init = 1

    if init == 1:
        iconNum = -1

        if ((x < 95) or (x > 615)) and reset == 0:
            for i in range (0,8):
                karamba.moveImage(widget, images[i], (i*65)+35+60, 72)
                karamba.moveImage(widget, imagesBig[i], (i*65)+35+60, 150)
                karamba.moveImage(widget, barimage, 60, 62)                
                karamba.moveImage(widget, barimageBig, 6, 150)                
            karamba.redrawWidget(widget)
            reset = 1
        elif ((y < 38) or (y > 144)) and reset == 0:
            for i in range (0,8):
                karamba.moveImage(widget, images[i], (i*65)+35+60, 72)
                karamba.moveImage(widget, imagesBig[i], (i*65)+35+60, 150)
                karamba.moveImage(widget, barimage, 60, 62)                
                karamba.moveImage(widget, barimageBig, 6, 150)                
            karamba.redrawWidget(widget)
            reset = 1
        elif (x >= 95)  and ((y >= 38) and (y <= 144)):
            iconNum = (x - 95) / 65
            offset = (x - 95) % 65
            reset = 1
            if ( -1 < iconNum < 8):
                if (iconNum != currZoomedPic) or (reset == 1):
                    karamba.moveImage(widget, barimage, 60, 160)                
                    karamba.moveImage(widget, barimageBig, 6, 62)                

                    reset = 0
                    karamba.moveImage(widget, images[currZoomedPic], (currZoomedPic*65)+35+60, 10)
                    karamba.moveImage(widget, imagesBig[currZoomedPic], (currZoomedPic*65)+35+60, 150)
                    if currZoomedPic != 0:
                        karamba.resizeImage(widget, imagesBig[currZoomedPic-1], 96, 96)
                        karamba.moveImage(widget, imagesBig[currZoomedPic-1], ((currZoomedPic-1)*65)+35+60, 150)
                        karamba.moveImage(widget, images[currZoomedPic-1], ((currZoomedPic-1)*65)+35+60, 42)
                    if currZoomedPic != 7:
                        karamba.resizeImage(widget, imagesBig[currZoomedPic+1], 96, 96)
                        karamba.moveImage(widget, imagesBig[currZoomedPic+1], ((currZoomedPic+1)*65)+35+60, 150)
                        karamba.moveImage(widget, images[currZoomedPic+1], ((currZoomedPic+1)*65)+35+60, 42)
                        
                    if offset < 36:    
                        karamba.resizeImage(widget, imagesBig[iconNum], 128-(35-(offset/2)), 128-(35-(offset/2)))
                        karamba.moveImage(widget, imagesBig[iconNum], (((iconNum+1)*65)+60+35+(70-offset)+((iconNum-1)*65)+60+35-(offset))/2, 45-((offset/2)))
                    else:
                        karamba.resizeImage(widget, imagesBig[iconNum], 128-(offset/2), 128-(offset/2))
                        karamba.moveImage(widget, imagesBig[iconNum], (((iconNum+1)*65)+60+35+(70-offset)+((iconNum-1)*65)+60+35-(offset))/2, 52-(42-(offset/2)))
                        
                    karamba.moveImage(widget, images[iconNum], (iconNum*65)+60+35, 150)
                    if iconNum != 0:
                        karamba.resizeImage(widget, imagesBig[iconNum-1], 96-(offset/2), 96-(offset/2))
                        karamba.moveImage(widget, imagesBig[iconNum-1], 60+((iconNum-1)*65)-(offset/2), 40+(offset/2))
                        karamba.moveImage(widget, images[iconNum-1], ((iconNum-1)*65)+35+60, 150)
                        for i in range (0, iconNum-1):
                            karamba.moveImage(widget, images[i], ((i)*65)-35+60, 72)
                            
                    if iconNum != 7:
                        karamba.resizeImage(widget, imagesBig[iconNum+1], 96-(35-(offset/2)), 96-(35-(offset/2)))
                        karamba.moveImage(widget, imagesBig[iconNum+1], 60+((iconNum+1)*65)+70 +35 -(offset/2), 40+35-(offset/2))
                        karamba.moveImage(widget, images[iconNum+1], ((iconNum+1)*65)+35+60, 150)
                        for i in range (iconNum+2, 8):
                            karamba.moveImage(widget, images[i], ((i)*65)+65+35+60, 72)
                    karamba.redrawWidget(widget)
                currZoomedPic = iconNum

                
# This will be printed when the widget loads.
print "Loaded my python extension!"

