#!/usr/bin/perl



$capacity = `cat /proc/acpi/battery/BAT1/info | grep 'design capacity'`;
$remain = `cat /proc/acpi/battery/BAT1/state | grep 'remaining capacity'`;

   chop($capacity);
   @capval = split/:/,$capacity;
   @capval = split/mWh/,$capval[1];

   chop($remain);
   @remval = split/:/,$remain;
   @remval = split/mWh/,$remval[1];


   $percent = sprintf("%.04f",$remval[0] / $capval[0])*100;


$info = `cat /proc/acpi/battery/BAT1/state | grep 'charging state'`;
if (!length($info))
{
   $info = `/sbin/iwconfig eth1 | grep 'ESSIF'`;
}
if (length($info))
{
   chop($info);
   @stat = split/: /,$info;
   @stat = split/ /,$stat[1];
   $status = $stat[9];

   if($percent == 100){
	print "Fully Charged\n";
   }
   elsif($percent < 10){
   	if($status eq "discharging"){
		print "Really Low\n";
	}
	else{
		print $status."\n";
	}
   }
   else{
	print $status."\n";
   }
}
else
{
   print "Someting is wrong\n";
}
