# -*- coding: iso-8859-1 -*-

import locale

defaultLang = "en"
_lang = {}
_lang["en"] = {}
_lang["fr"] = {}

# English version
_lang["en"]["propItem"] = "Properties"
_lang["en"]["delItem"] = "Remove"
_lang["en"]["umountItem"] = "Unmount"
_lang["en"]["mountItem"] = "Mount"
_lang["en"]["umountError"] = "Device is busy"
_lang["en"]["mountError"] = "Device cannot be mounted"
_lang["en"]["badDesktop"] = "Not a device file dropped"
_lang["en"]["loadSuccess"] = "Loaded KarDevices!"
_lang["en"]["scrollOption"] = "Show scroll buttons"
_lang["en"]["popupOption"] = "Show menu button"
_lang["en"]["menuTooltip"] = "Show options menu"

# Version franaise
_lang["fr"]["propItem"] = "Proprits"
_lang["fr"]["delItem"] = "Supprimer"
_lang["fr"]["umountItem"] = "Dmonter"
_lang["fr"]["mountItem"] = "Monter"
_lang["fr"]["umountError"] = "Priphrique occup"
_lang["fr"]["mountError"] = "Le priphrique ne peut pas tre mont"
_lang["fr"]["badDesktop"] = "Ce n'est pas un fichier de priphrique"
_lang["fr"]["loadSuccess"] = "KarDevices dmarr !"
_lang["fr"]["scrollOption"] = "Afficher boutons de dfilement"
_lang["fr"]["popupOption"] = "Afficher bouton de menu"
_lang["fr"]["menuTooltip"] = "Afficher le menu d'options"

#Get current language

tmp_lang = locale.getdefaultlocale()[0]
if (tmp_lang == None):
    tmp_lang = defaultLang

userLang = tmp_lang[0:2]
if (not _lang.has_key(userLang)):
    userLang = defaultLang

lang = _lang[userLang]
