#aSysMon... part of a'Sensors 2.0, written by Aristo <aristomeneses@yahoo.com>
import karamba
import os

data = [0,0,0,0]

#this is called when your widget is initialized...
def initWidget(widget):
	global procModel, vendorID, Mhz, Cache, gridMem, gridSwap
	
	data[0] = os.popen("cat /proc/cpuinfo | grep 'vendor_id' | sed -e 's/.*:.//'")
	vendorID = data[0].read()
	print "vendorID"
	#shows processor logo
	if ( vendorID == "GenuineIntel\n" ):
		logo = karamba.createImage(widget, 95, 25, "pics/intel.png")
	else :
		logo = karamba.createImage(widget, 95, 25, "pics/amd.png")
	
	procModel = karamba.createText(widget, 55, 25, 200, 15, "")
	karamba.changeTextFont(widget, procModel, 'Fixed')
	karamba.changeTextColor(widget, procModel, 0, 0, 0)
	karamba.changeTextSize(widget, procModel, 10)
	
	Mhz = karamba.createText(widget, 55, 40, 170, 20, "")
	karamba.changeTextFont(widget, Mhz, 'Fixed')
	karamba.changeTextColor(widget, Mhz, 0, 0, 0)
	karamba.changeTextSize(widget, Mhz, 10)
	
	Cache = karamba.createText(widget, 160, 39, 150, 20, "")
	karamba.changeTextFont(widget, Cache, 'Fixed ')
	karamba.changeTextColor(widget, Cache, 0, 0, 0)
	karamba.changeTextSize(widget, Cache, 9)
	
#this is called when your widget i supdated, the interval is in the .theme
def widgetUpdated(widget):
	global procModel, Mhz, Cache, logo
	
	data[1] = os.popen("cat /proc/cpuinfo | grep 'model name' | sed -e 's/.*:.//'")
	data[2] = os.popen("cat /proc/cpuinfo | grep 'cpu MHz' | sed -e 's/.*:.//'")
	data[3] = os.popen("cat /proc/cpuinfo | grep 'cache size' | sed -e 's/.*:.//'")
	
	pm = data[1].read()
	print "procModel"
	mhz = data[2].read()
	print "mhz"
	cache = data[3].read()
	print "cache"
	
	if( pm.count("Pentium(R) 4") == 1) :
		logo = karamba.createImage(widget, 4, 30, "pics/p4.png")
		
	elif ((pm.count("Athlon") == 1) and (pm.count("64") == 1) and (pm.count("Fx") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/athlon64fx.png")
	
	elif ((pm.count("Athlon") == 1) and (pm.count("64") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/athlon64.png")

	elif ((pm.count("Athlon") == 1) and (pm.count("XP") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/Athlonxp.png")
	
	elif ((pm.count("Sempron") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/sempron.png")
	
	elif ((pm.count("Celeron") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/Celeron.png")
	
	elif ((pm.count("Coppermine") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/pIII.png")

	elif ((pm.count("Itanium") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/itanium.png")
	
	elif ((pm.count("Xeon") == 1)) :
		logo = karamba.createImage(widget, 4, 30, "pics/xeon.png")

	karamba.changeText(widget, procModel, pm)
	karamba.changeText(widget, Mhz, "Speed: " + mhz[0:4] + " Mhz")
	karamba.changeText(widget, Cache, "Cache: " + cache)
	
##La experiencia es una una dura maestra; primero ponela prueba, luego da la explicacin...