#!/usr/bin/env python

# Emmanuel Gagniere 2003
# acpimon v 0.0.1 is under GPL

import string
import os
import re


class acpiWrapper:
    def __init__(self):
        self.Command = "acpi -V"
        self.Results = os.popen(self.Command).readlines()
        if len(self.Results) == 0:
            print "Please check that acpi is installed."
            return

    
    def returnStatus(self):
        batteryLeft, timeRemaining = self.battery()
        acStatus = self.ac()
        return batteryLeft, timeRemaining, acStatus
        
    # battery function returns the battery left (in %) and the time remaining
    
    
    def battery(self):
        matchBatteryLeft = re.search("%",self.Results[0])
        batteryLeft = self.Results[0][matchBatteryLeft.start()-3:matchBatteryLeft.start()]
        print batteryLeft
        batteryLeft = int(string.replace(batteryLeft,",",""))
    
        matchTimeRemaining = re.search("remaining",self.Results[0])
        if matchTimeRemaining != None:
            timeRemaining = self.Results[0][matchTimeRemaining.start()-9:matchTimeRemaining.start()-1]
        else:
            timeRemaining = "unknown"
        
        return batteryLeft, timeRemaining
        
    # ac function returns "on-line" if the laptop is connected, "off-line" if not    
    
    def ac(self):
        acStatus=re.search("on-line",self.Results[2])
        
        if acStatus != None:
            return "on-line"
        else:
            return "off-line"
        
    
