############################################################################
#    Copyright (C) 2004 by Bobby Z.                                        #
#    ziuchkov@uiuc.edu                                                     #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import player
import xmms

class Pyxmms(player.Player):
   def __init__(self):
      self.chkPosition()
      self.chkLength()
      self.chkSong()
   def chkPosition(self):
      self.position = xmms.get_output_time() / 1000
   def chkLength(self):
      self.length = xmms.get_playlist_time(xmms.get_playlist_pos()) / 1000
   def chkSong(self):
      self.song = xmms.get_playlist_title(xmms.get_playlist_pos())
   def seekPrev(self):
      xmms.playlist_prev()
   def seekNext(self):
      xmms.playlist_next()
   def seekPrevOffset(self, offset):
      xmms.jump_to_time((self.position - offset) * 1000)
   def seekNextOffset(self, offset):
      xmms.jump_to_time((self.position + offset) * 1000)
   def seekTime(self, seektime):
      xmms.jump_to_time(seektime * 1000)
   def cmdPause(self):
      xmms.play_pause()
   def cmdStop(self):
      xmms.stop()
   def cmdPlay(self):
      xmms.play()
