import karamba
import icon
from docklet import Docklet
import os
import os.path
import time

class XMMSDocker (Docklet):
	def __init__ (self, widget, x, y, path):
		Docklet.__init__(self, widget, "XMMSDocker", x, y, path)
		self.controls = karamba.createImage(widget, x, y-8, os.path.dirname(path)+"/"+"xmms-controls.png")
		karamba.hideImage(widget, self.controls)
		karamba.resizeImage(widget, self.controls, 64, 10)
		#self.titleText = "Test text"
		#self.title = karamba.createText(widget, x+64-8*len(self.titleText), y-7-15, 250, 12, "")
		#karamba.changeTextColor(widget, self.title, 255, 255, 255)
		#karamba.changeTextSize(widget, self.title, 10)
		#karamba.changeTextFont(widget, self.title, "Courier New")

		self.showing = 0

		self.notify = 1

	def updateTitle(self, widget):
		while self.notify:
			if self.showing:
				pass
			time.sleep(2.0)

	def click(self, widget, x, y, button):
		if 8 <= y <= 8+48:
			if self.showing:
				karamba.hideImage(widget, self.controls)
				#karamba.changeText(widget, self.title, "")
				karamba.redrawWidget(widget)
				self.showing = 0
			else:
				karamba.showImage(widget, self.controls)
				#karamba.changeText(widget, self.title, self.titleText)
				karamba.redrawWidget(widget)
				self.showing = 1
		elif y < 8:
			if self.showing:
				if -7 <= y <= 0:
					control = (x - (64-52)/2) / 11
					if control == 0:
						os.system("xmms-shell -e 'window all toggle'")
					if control == 1:
						os.system("xmms-shell -e 'back'")
					if control == 2:
						os.system("xmms-shell -e 'stop'")
					if control == 3:
						os.system("xmms-shell -e 'play'")
					if control == 4:
						os.system("xmms-shell -e 'forward'")
			pass


