# eye.one-calls superkaramba theme by ramone@oxibiose.dyndns.org
# tested with superkaramba-0.27
#this import statement allows access to the karamba functions
import karamba
import os
import string

init = 0
numOfTasks = 0

taskPanels = []
taskText = []


#this is called when you widget is initialized
def initWidget(widget):

	karamba.createBackgroundImage(widget, 0, 0, "pics/back_calls.png")
	karamba.createBackgroundImage(widget, 0, 75, "pics/moverh.png")
	karamba.createImage(widget, 5, 124, "pics/superkaramba.png")

	global m
	m = 0
	global resX
	global resY
	
	havexwi = os.system("which xwininfo")

	if (havexwi == 0):
		pass
	else:
		print "\nCan't find xwininfo in your path."

	fp = os.popen("xwininfo -root -stats")
	output = fp.read()
	output = output.splitlines()
	fp.close()
	i = 0
	for x in output:
		param = x.split()

		if (len(param) > 1):
			if param[0].find("Width:") != -1:
				resX = int(param[1])
			if param[0].find("Height:") != -1:
				resY = int(param[1])
				

	karamba.moveWidget(widget, (resX - 630), (resY - 150))

	karamba.redrawWidgetBackground(widget)

	global positiona
	global positionb
	positiona = karamba.getWidgetPosition(widget)
	positionb = positiona

# programms & icons

	global programm
	global icon
	global icons
	global chunks
	global pathtoconf
	global lock
	global shutdown
	global configure
	global lock
	global shutdown
	global progRun
	global progRunIcon
	programm = []
	progRun = []
	progRunIcon = []
	icon = []
	icons = []
	lines = []
	chunks = 0
	pathtoconf = karamba.getThemePath(widget)
	conffile = open(pathtoconf + '/calls.conf', 'r')
	while 1:
		line = conffile.readline()
		if not line:
			break
		elif line.startswith('\n'):
			continue
		elif line.startswith('#'):
			continue
		else:
			lines.append(line.strip('\n'))
			chunks = chunks + 1

	chunks = chunks/3

	n = 0
	for i in range(0, chunks):
		progRun.append(lines[n].strip('[]'))
		n = n + 3
	n = 1
	for i in range(0, chunks):
		programm.append(lines[n])
		n = n + 3
	n = 2
	for i in range(0, chunks):
		icon.append(lines[n])
		n = n + 3

	global configure
	global kmenu
	global lock
	global shutdown

	configure = karamba.createImage(widget, 42, 10, "pics/configure.png")
	karamba.addImageTooltip(widget, configure, "Edit Icons & Programm calls")
	kmenu = karamba.createImage(widget, 38, 70, "pics/kmenu.png")
	karamba.addImageTooltip(widget, kmenu, "KDE Menu")
	lock = karamba.createImage(widget, 38, 98, "pics/appicons/lock.png")
	shutdown = karamba.createImage(widget, 38, 122, "pics/appicons/exit.png")
	a = 0
	b = 0
	c = 0
	i = 0
	for i in range(chunks):
		if ( i <= 3 ):
			icons.append(karamba.createImage(widget, ( 86 + a ), 10, "pics/appicons/" + icon[i]))
			progRunIcon.append(karamba.createImage(widget, ( 86 + a ), 30, "pics/1uparrow.png"))
			a = a + 54
		if ( i > 3 ) and ( i < 8):
			icons.append(karamba.createImage(widget, ( 86 + b ), 60, "pics/appicons/" + icon[i]))
			progRunIcon.append(karamba.createImage(widget, ( 86 + b ), 80, "pics/1uparrow.png"))
			b = b + 54
		if ( i >= 8 ) and ( i < 12):
			icons.append(karamba.createImage(widget, ( 86 + c ), 110, "pics/appicons/" + icon[i]))
			progRunIcon.append(karamba.createImage(widget, ( 86 + c ), 130, "pics/1uparrow.png"))
			c = c + 54
		if ( i >= 12):
			os.system("kdialog --error \"There are more than 12 Icons found!  Thats 2 much 4 this theme - only 12 are allowed. Sorry.  \nmailto: ramone@oxibiose.dyndns.org for further info. \" --title \"Bad Icon Count\"")
			print "\nAnyway - have a nice day!"
		karamba.hideImage(widget, progRunIcon[i])
#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):

	global init
	global numOfTasks
	global taskPanels
	global taskText
	global taskNames
	global taskInfo
	global progRun
	global progRunIcon
	e = 0
	taskInfo = []
	if init == 0:

		numOfTasks = 150/15  ## funny!


		for i in range(numOfTasks):
			if ( i <= 4 ) :
				taskPanels.append(karamba.createImage(widget, 304,  12 + (26*i), "pics/taskback.png"))
				taskText.append(karamba.createText(widget,  ( 304 + 8 ), 12 + (26*i) + 4, 141, 20,""))
			if ( i > 4 ) :
				taskPanels.append(karamba.createImage(widget, 464,  12 + (26*e), "pics/taskback.png"))
				taskText.append(karamba.createText(widget,  ( 464 + 8 ), 12 + (26*e) + 4, 141, 20,""))
				e = e + 1
		for text in taskText:
			karamba.changeTextColor(widget,text, 255, 255, 255)
			karamba.changeTextFont(widget, text, "verdana")
			karamba.changeTextSize(widget,text, 9)

		init = 1

	taskList = karamba.getTaskList(widget)

	taskNames = karamba.getTaskNames(widget)

	for i in range(len(taskList)):
		taskInfo.append(karamba.getTaskInfo(widget, taskList[i])[2])

################################################################
### this is to get to know how the calls [entry] has to be named
#	print taskInfo
################################################################

	for i in range(len(progRun)):
		karamba.hideImage(widget, progRunIcon[i])
		if ( progRun[i] in taskInfo > 0):
			karamba.showImage(widget, progRunIcon[i])
		elif ( progRun[i] in taskInfo == 0):
			karamba.hideImage(widget, progRunIcon[i])


	for image in taskPanels:
		karamba.hideImage(widget, image)

	for text in taskText:
		karamba.changeText(widget, text, "")
		karamba.changeTextColor(widget,text, 255, 255, 255)

	length = len(taskList)
	if (numOfTasks < length):
		length = numOfTasks

	for j in range(length):
		taskinfo = karamba.getTaskInfo(widget, taskList[j])

		karamba.showImage(widget, taskPanels[j])
		karamba.changeText(widget, taskText[j], taskinfo[0])

		if (taskinfo[7] == 1):
			karamba.changeTextColor(widget, taskText[j], 0, 0, 102)

		if (taskinfo[5] == 1):
			karamba.changeTextColor(widget,taskText[j], 185, 207, 240)

	karamba.redrawWidget(widget)
#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):

# move widget	
	global positiona
	global positionb
	 
	if ( x >= 0 ) and ( x <= 30 )  and ( positiona[0] == positionb[0] ) and (button == 1):
		i = positiona[0]
		g = 0
		while g < 601 :
			karamba.moveWidget(widget, i, positiona[1])
			i = i + 5
			g = g + 5
		positionb = karamba.getWidgetPosition(widget)		
	elif ( x >= 0 ) and ( x <= 30 ) and ( positiona[0] <> positionb[0] ) and (button == 1):
		i = positionb[0]
		g = 0
		while g < 601 :
			karamba.moveWidget(widget, i, positionb[1])
			i = i - 5
			g = g + 5
		positionb = karamba.getWidgetPosition(widget)
		positiona = positionb

	global numOfTasks
	global taskPanels
	global taskText

	taskSelected = y/26
	taskSelected0 = ( taskSelected + 5 )

    ## Make sure its a valid task
	if  ( x < 464 ) and ( x > 304 ) and (0 <= taskSelected < numOfTasks):
		taskList = karamba.getTaskList(widget)
	    
	    ## perform the task action (see Task API for list of numbers)
	    	karamba.performTaskAction(widget, taskList[taskSelected], 8)
	    
	if ( x < 464 ) and ( x > 304 ) and (taskSelected == numOfTasks):
		karamba.toggleShowDesktop(widget)

	if ( x > 464 ) and (0 <= taskSelected0 < numOfTasks):
		taskList = karamba.getTaskList(widget)
	    
	    ## perform the task action (see Task API for list of numbers)
	    	karamba.performTaskAction(widget, taskList[taskSelected0], 8)
	    
	if ( x > 464 ) and (taskSelected0 == numOfTasks):
		karamba.toggleShowDesktop(widget)
        
# programcalls

	if (x >= 42) and (x < 59) and (y >= 10) and (y < 27):
		os.system('kwrite' + " " + pathtoconf + '/calls.conf' + ' &')
	if (x >= 38) and (x < 55) and (y >= 70) and (y < 93):
		os.system('dcop kicker kicker popupKMenu 0 &')
	if (x >= 38) and (x < 55) and (y >= 98) and (y < 115):
		os.system('dcop kdesktop KScreensaverIface lock')
	if (x >= 38) and (x < 55) and (y >= 122) and (y < 147):
		os.system('dcop kdesktop KDesktopIface logout')
	
	global programm
	
	if(x > 86) and (x < 294) :
		xpos = ( x - 86 )/52
		if ( y > 10 ) and ( y < 60 ):
			command_string = programm[xpos] + " &"
		if ( y >= 60 ) and ( y < 110 ):
			command_string = programm[xpos + 4] + " &"
		if ( y >= 110 ) and ( y < 150 ):
			command_string = programm[xpos + 8] + " &"
		os.system(command_string)
#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
#    pass
	global configure
	global kmenu
	global lock
	global shutdown
	
	if (x >= 42) and (x < 59) and (y >= 10) and (y < 27):
		karamba.changeImageIntensity(widget, configure, 0.3) 
	else:
		karamba.removeImageEffects(widget, configure)
	if (x >= 38) and (x < 55) and (y >= 70) and (y < 93):
			karamba.changeImageIntensity(widget, kmenu, 0.3) 
	else:
		karamba.removeImageEffects(widget, kmenu)
	if (x >= 38) and (x < 55) and (y >= 98) and (y < 115):
		karamba.changeImageIntensity(widget, lock, 0.3) 
	else:
		karamba.removeImageEffects(widget, lock)
	if (x >= 38) and (x < 55) and (y >= 122) and (y < 147):
		karamba.changeImageIntensity(widget, shutdown, 0.3) 
	else:
		karamba.removeImageEffects(widget, shutdown)
		
	global icons
	global chunks
	global m
	
	if ( m == 1):
		for i in range(chunks):
			karamba.resizeImageSmooth(widget, icons[i], 32, 32)
		m = 0

	if(x > 86) and (x < 294):
		xpos = ( x - 86 )/52
		if ( y > 10 ) and ( y < 60 ):
			karamba.resizeImageSmooth(widget, icons[xpos], 38, 38)
		elif ( y >= 60 ) and ( y < 110 ):
			xpos = xpos + 4
			karamba.resizeImageSmooth(widget, icons[xpos], 38, 38)
		elif ( y >= 110 ) and ( y < 150 ):
			xpos = xpos + 8
			karamba.resizeImageSmooth(widget, icons[xpos], 38, 38)
		m = 1
# This will be printed when the widget loads.
print ""
print "Loaded eyeon-calls.theme python extension."
print "Suggestions welcome to ramone@oxibiose.dyndns.org !"
print ""
