# eye.one superkaramba theme by ramone@oxibiose.dyndns.org
# tested with superkaramba 0.27
#this import statement allows access to the karamba functions
import karamba
import os
import string
import sys
import socket
import time
import commands

xpos=0

h = 1
k = - 1	
#this is called when you widget is initialized
def initWidget(widget):

	global xpos
	
	_xpos=karamba.readConfigEntry(widget,"widgetPosX");
	if (_xpos != None):
		xpos=_xpos
	
	
	karamba.moveWidget(widget, xpos, -600)
#check filesystem
	global all
	global label
	global m
	global disk
	global drive
	global disktotal
	global diskfree
	global diskbar
	global drivesize
	global pics
	global which
	global k
	global total
	global free
	global percent
	global arrow
	global drivemenu

	all = []
	disk = [0, 1, 2, 3]
	drive = [0, 1, 2, 3]
	disktotal = [0, 1, 2, 3]
	diskfree = [0, 1, 2, 3]
	diskbar = [0, 1, 2, 3]
	drivesize = [0, 1, 2, 3]
	which = [0, k - 2, k - 1, k]
	mountpoint = []
	arrow = []
	k = -1
	m = 0
	d = (325, 340, 353)
	e = 0

	_disk0=karamba.readConfigEntry(widget,"disk0")
	if (_disk0 != None):
		which[0]=_disk0

	_disk1=karamba.readConfigEntry(widget,"disk1")
	if (_disk1 != None):
		which[1]=_disk1

	_disk2=karamba.readConfigEntry(widget,"disk2")
	if (_disk2 != None):
		which[2]=_disk2

	_disk3=karamba.readConfigEntry(widget,"disk3")
	if (_disk3 != None):
		which[3]=_disk3
	



	getDiskInfo(all)
	
	drivemenu = karamba.createMenu(widget)

	for i in range(4):

		drive[i] = karamba.createImage(widget, 8, (d[1] + e), pics[which[i]])
		karamba.addImageTooltip(widget, drive[i],"Konqueror "+label[which[i]])
		disk[i] = karamba.createText(widget, 35, (d[0] + e), 110, 14, label[which[i]])
		karamba.changeTextFont(widget, disk[i], 'verdana')
		karamba.changeTextSize(widget, disk[i], 10)
		karamba.changeTextColor(widget, disk[i], 255, 255, 255)
		disktotal[i] = karamba.createText(widget, 35, (d[1] + e), 110, 14, 'total	'+total[which[i]])
		karamba.changeTextFont(widget, disktotal[i], 'verdana')
		karamba.changeTextSize(widget, disktotal[i], 9)
		karamba.changeTextColor(widget, disktotal[i], 255, 255, 255)
		diskfree[i] = karamba.createText(widget, 35, (d[2] + e), 110, 14, 'free	'+free[which[i]])
		karamba.changeTextFont(widget, diskfree[i], 'verdana')
		karamba.changeTextSize(widget, diskfree[i], 9)
		karamba.changeTextColor(widget, diskfree[i], 255, 255, 255)
		karamba.createImage(widget, 40, (370 + e), "pics/diskbarback.png")
		arrow.append(karamba.createImage(widget, 10, (362 + e), "pics/2rightarrow.png"))
		karamba.addImageTooltip(widget, arrow[i], "Choose Drive 2 display")
		if ( int(percent[which[i]]) == 0) and ( total[which[i]] == '0' ):
			pass
		elif ( int(percent[which[i]]) <= 70):
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskempty.png")
		elif ( int(percent[which[i]])  > 70) and ( int(percent[which[i]])  < 90):
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskhalf.png")
		else :
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskfull.png")
		diskbar[i] = karamba.createImage(widget, 40, (370 + e), "pics/barmeter.png")
		karamba.resizeImage(widget, diskbar[i], int(percent[which[i]]), 4)
		e = e + 60

# widget text & mover
	karamba.createBackgroundImage(widget, 0, 0, "pics/back_main.png")
	karamba.createBackgroundImage(widget, 0, 600, "pics/mover.png")
	karamba.createImage(widget, 5, 604, "pics/gomover.png")
	
	headline = karamba.createText(widget, 35, 0, 110, 26, 'eye.on')
	karamba.changeTextFont(widget, headline, 'verdana')
	karamba.changeTextSize(widget, headline, 16)
	karamba.changeTextColor(widget, headline, 255, 255, 255)

	try:
		user = os.environ["USER"]
	except:
		user = "unknow user"

	username = karamba.createText(widget, 35, 63, 110, 14, user)
	karamba.changeTextFont(widget, username, 'verdana')
	karamba.changeTextSize(widget, username, 9)
	karamba.changeTextColor(widget, username, 255, 255, 255)

	try:
		machine = os.environ["HOSTNAME"]
	except:
		machine="localhost"

	machinename = karamba.createText(widget,35, 77, 110, 14, machine)
	ip = socket.gethostbyname(machine)
	machineip = karamba.createText(widget,35, 92, 110, 14, ip)
	karamba.changeTextFont(widget, machineip, 'verdana')
	karamba.changeTextSize(widget, machineip, 9)
	karamba.changeTextColor(widget, machineip, 255, 255, 255)
	karamba.changeTextFont(widget, machinename, 'verdana')
	karamba.changeTextSize(widget, machinename, 9)
	karamba.changeTextColor(widget, machinename, 255, 255, 255)
	cpu0 = karamba.createText(widget, 35, 118, 35, 14, 'CPU')
	karamba.changeTextFont(widget, cpu0, 'verdana')
	karamba.changeTextSize(widget, cpu0, 10)
	karamba.changeTextColor(widget, cpu0, 255, 255, 255)
	netin = karamba.createText(widget, 35, 168, 35, 14, 'IN')
	karamba.changeTextFont(widget, netin, 'verdana')
	karamba.changeTextSize(widget, netin, 10)
	karamba.changeTextColor(widget, netin, 255, 255, 255)
	netout = karamba.createText(widget, 35, 220, 35, 14, 'OUT')
	karamba.changeTextFont(widget, netout, 'verdana')
	karamba.changeTextSize(widget, netout, 10)
	karamba.changeTextColor(widget, netout, 255, 255, 255)
	mem0 = karamba.createText(widget, 35, 266, 35, 14, 'mem')
	karamba.changeTextFont(widget, mem0, 'verdana')
	karamba.changeTextSize(widget, mem0, 8)
	karamba.changeTextColor(widget, mem0, 255, 255, 255)
	mem1 = karamba.createText(widget, 35, 294, 35, 14, 'swap')
	karamba.changeTextFont(widget, mem1, 'verdana')
	karamba.changeTextSize(widget, mem1, 8)
	karamba.changeTextColor(widget, mem1, 255, 255, 255)
	

# icons & tooltips
	global go
	global desktoptoggle
	global mech
	global cpu
	global netyellow
	global netgreen
	global mem
	

	go = karamba.createImage(widget, 8, 8, "pics/go.png")
	karamba.addImageTooltip(widget, go, "KDE Menu")
	desktoptoggle = karamba.createImage(widget, 8, 38, "pics/desktop.png")
    	karamba.addImageTooltip(widget, desktoptoggle, "Toggle Desktop")
	mech = karamba.createImage(widget, 8, 78, "pics/konsole.png")
    	karamba.addImageTooltip(widget, mech, "Konsole")
	cpu = karamba.createImage(widget, 8, 128, "pics/cpu.png")
	karamba.addImageTooltip(widget, cpu, "Ksysguard")
	netyellow = karamba.createImage(widget, 8, 178, "pics/netyellow.png")
	karamba.addImageTooltip(widget, netyellow, "Konqueror WWW")
	netgreen = karamba.createImage(widget, 8, 228, "pics/netgreen.png")
	karamba.addImageTooltip(widget, netgreen, "Mozilla WWW")
	mem = karamba.createImage(widget, 8, 288, "pics/mem.png")
	karamba.addImageTooltip(widget, mem, "Kinfocenter")
	
# 
#date & time
	global now
	global thetime
	global thedate
	from time import localtime, strftime
	thetime = strftime("%H:%M:%S", localtime())
	thedate = strftime("%a %d %b %Y", localtime())
	now = karamba.createText(widget, 30, 568, 140, 22, thetime)
	karamba.changeTextFont(widget, now, 'verdana')
	karamba.changeTextSize(widget, now, 16)
	karamba.changeTextColor(widget, now, 255, 255, 255)
	
	global desktop
	global desktoptext
	
	desktop = [1, 2, 3, 4, 5]
	desktoptext = [1, 2, 3, 4, 5]
	e = 0
	for i in range(1, 5):
		desktop[i] = karamba.createImage(widget, ( 35 + e ), 36, "pics/deskno.png")
		desktoptext[i] = karamba.createText(widget, (42 + e), 37, 14, 14, str(i))
		karamba.changeTextFont(widget, desktoptext[i], 'verdana')
		karamba.changeTextSize(widget, desktoptext[i], 8)
		karamba.changeTextColor(widget, desktoptext[i], 204, 204, 204)
		karamba.addImageTooltip(widget, desktop[i], "Desktop " + str(i))
		e = e + 28
#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):



# date & time	
	global h
	global now
	global thetime
	global thedate
	if (h == 1):
		from time import localtime, strftime
		thetime = strftime("%H:%M:%S", localtime())
		thedate = strftime("%a %d %b %Y", localtime())
		karamba.deleteText(widget, now)
		now = karamba.createText(widget, 30, 568, 140, 22, thetime)
		karamba.changeTextFont(widget, now, 'verdana')
		karamba.changeTextSize(widget, now, 16)
		karamba.changeTextColor(widget, now, 255, 255, 255)
	if (h <> 1):
		from time import localtime, strftime
		thetime = strftime("%H:%M:%S", localtime())
		thedate = strftime("%a %d %b %Y", localtime())
		karamba.deleteText(widget, now)
		now = karamba.createText(widget, 16, 574, 140, 22, thedate)
		karamba.changeTextFont(widget, now, 'verdana')
		karamba.changeTextSize(widget, now, 11)
		karamba.changeTextColor(widget, now, 255, 255, 255)

# the hardrives update thing
	global label
	global m
	global disk
	global drive
	global disktotal
	global diskfree
	global diskbar
	global drivesize
	global pics
	global k
	global total
	global free
	global percent
	global which
	global all
	mountpoint = []
	k = -1
	m = 0
	d = (325, 340, 353)
	e = 0
	l = 0

	getDiskInfo(all)

	for i in range(4):
		karamba.deleteImage(widget, drive[i])
		drive[i] = karamba.createImage(widget, 8, (d[1] + e), pics[which[i]])
		karamba.addImageTooltip(widget, drive[i],"Konqueror "+label[which[i]])
		karamba.deleteText(widget, disk[i])
		disk[i] = karamba.createText(widget, 35, (d[0] + e), 110, 14, label[which[i]])
		karamba.changeTextFont(widget, disk[i], 'verdana')
		karamba.changeTextSize(widget, disk[i], 10)
		karamba.changeTextColor(widget, disk[i], 255, 255, 255)
		karamba.deleteText(widget, disktotal[i])
		disktotal[i] = karamba.createText(widget, 35, (d[1] + e), 110, 14, 'total	'+total[which[i]])
		karamba.changeTextFont(widget, disktotal[i], 'verdana')
		karamba.changeTextSize(widget, disktotal[i], 9)
		karamba.changeTextColor(widget, disktotal[i], 255, 255, 255)
		karamba.deleteText(widget, diskfree[i])
		diskfree[i] = karamba.createText(widget, 35, (d[2] + e), 110, 14, 'free	'+free[which[i]])
		karamba.changeTextFont(widget, diskfree[i], 'verdana')
		karamba.changeTextSize(widget, diskfree[i], 9)
		karamba.changeTextColor(widget, diskfree[i], 255, 255, 255)
		karamba.deleteImage(widget, drivesize[i])
		if ( int(percent[which[i]]) == 0) and ( total[which[i]] == '0' ):
			pass
		elif ( int(percent[which[i]]) <= 70):
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskempty.png")
		elif ( int(percent[which[i]])  > 70) and ( int(percent[which[i]])  < 90):
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskhalf.png")
		else :
			drivesize[i] = karamba.createImage(widget, 35, (370 + e), "pics/diskfull.png")
		karamba.deleteImage(widget, diskbar[i])
		diskbar[i] = karamba.createImage(widget, 40, (370 + e), "pics/barmeter.png")
		karamba.resizeImage(widget, diskbar[i], int(percent[which[i]]), 4)
		e = e + 60
		l = 1
#show current desktop
	global desktop
	global desktoptext
	temp = os.popen("dcop kwin KWinInterface currentDesktop")
	pager = temp.read()
	pager = pager.splitlines()
	pager = pager[0]
	temp.close()
	e = 0
	
	for i in range(1, 5):
		karamba.deleteImage(widget, desktop[i])
		karamba.deleteText(widget, desktoptext[i])
		if ( i == int(pager)):
			desktop[i] = karamba.createImage(widget, ( 35 + e ), 36, "pics/desk.png")
			desktoptext[i] = karamba.createText(widget, (42 + e), 37, 14, 14, str(i))
			karamba.changeTextFont(widget, desktoptext[i], 'verdana')
			karamba.changeTextSize(widget, desktoptext[i], 8)
			karamba.changeTextColor(widget, desktoptext[i], 255, 255, 255)
		elif( i <> int(pager)):
			desktop[i] = karamba.createImage(widget, ( 35 + e ), 36, "pics/deskno.png")
			desktoptext[i] = karamba.createText(widget, (42 + e), 37, 14, 14, str(i))
			karamba.changeTextFont(widget, desktoptext[i], 'verdana')
			karamba.changeTextSize(widget, desktoptext[i], 8)
			karamba.changeTextColor(widget, desktoptext[i], 204, 204, 204)
			karamba.addImageTooltip(widget, desktop[i], "Desktop " + str(i))
		e = e + 28

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):

# programm calls
	global label
	global which

	if (x >= 8) and (x < 25) and (y >= 8) and (y < 25) and (button == 1):
			os.system('dcop kicker kicker popupKMenu 150 &')
	if (x >= 8) and (x < 25) and (y >= 38) and (y < 55) and (button == 1):
			karamba.toggleShowDesktop(widget)
	if (x >= 35) and (x < 52) and (y >= 38) and (y < 55) and (button == 1):
			os.system('dcop kwin KWinInterface setCurrentDesktop 1')
	if (x >= 65) and (x < 82) and (y >= 38) and (y < 55) and (button == 1):
			os.system('dcop kwin KWinInterface setCurrentDesktop 2')
	if (x >= 95) and (x < 112) and (y >= 38) and (y < 55) and (button == 1):
			os.system('dcop kwin KWinInterface setCurrentDesktop 3')
	if (x >= 124) and (x < 141) and (y >= 38) and (y < 55) and (button == 1):
			os.system('dcop kwin KWinInterface setCurrentDesktop 4')
	if (x >= 8) and (x < 25) and (y >= 78) and (y < 95) and (button == 1):
			os.system('konsole &')
	if (x >= 8) and (x < 25) and (y >= 128) and (y < 145) and (button == 1):
			os.system('ksysguard')
	if (x >= 8) and (x < 25) and (y >= 178) and (y < 195) and (button == 1):
			os.system('kfmclient openProfile webbrowsing')
	if (x >= 8) and (x < 25) and (y >= 228) and (y < 245) and (button == 1):
			os.system('mozilla &')
	if (x >= 8) and (x < 25) and (y >= 283) and (y < 300) and (button == 1):
			os.system('kinfocenter')
	if (x >= 8) and (x < 25) and (y >= 340) and (y < 357) and (button == 1):
			os.system('konqueror' + " "  + label[which[0]] + ' &')
	if (x >= 8) and (x < 25) and (y >= 400) and (y < 417) and (button == 1):
			os.system('konqueror' + " "  + label[which[1]] + ' &')
	if (x >= 8) and (x < 25) and (y >= 460) and (y < 477) and (button == 1):
			os.system('konqueror' + " "  + label[which[2]] + ' &')
	if (x >= 8) and (x < 25) and (y >= 520) and (y < 537) and (button == 1):
			os.system('konqueror' + " " + label[which[3]] + ' &')

# choose harddrive
	global drivemenu
	global mountpoint
	global all
	global selection
	global pics
	global t
	t = 0
	selection = {}

	if (x >= 10) and (x < 27) and (y >= 362) and (y < 379) and (button == 1):
		karamba.deleteMenu(widget, drivemenu)
		getDiskInfo(all)
		drivemenu = karamba.createMenu(widget)
		for i in range(0, len(label)):
			item = karamba.addMenuItem(widget, drivemenu, ("Device: %s @ Mountpoint: %s" % (mountpoint[i], label[i])), 'kdf')
			if item < 0:
				item = item * -1
			selection[item] = i
		karamba.popupMenu(widget, drivemenu, x, y)
	if (x >= 10) and (x < 27) and (y >= 422) and (y < 439) and (button == 1):
		t = 1
		karamba.deleteMenu(widget, drivemenu)
		getDiskInfo(all)
		drivemenu = karamba.createMenu(widget)
		for i in range(0, len(label)):
			item = karamba.addMenuItem(widget, drivemenu, ("Device: %s @ Mountpoint: %s" % (mountpoint[i], label[i])), 'kdf')
			if item < 0:
				item = item * -1
			selection[item] = i
		karamba.popupMenu(widget, drivemenu, x, y)
	if (x >= 10) and (x < 27) and (y >= 482) and (y < 499) and (button == 1):
		t = 2
		karamba.deleteMenu(widget, drivemenu)
		getDiskInfo(all)
		drivemenu = karamba.createMenu(widget)
		for i in range(0, len(label)):
			item = karamba.addMenuItem(widget, drivemenu, ("Device: %s @ Mountpoint: %s" % (mountpoint[i], label[i])), 'kdf')
			if item < 0:
				item = item * -1
			selection[item] = i
		karamba.popupMenu(widget, drivemenu, x, y)
	if (x >= 10) and (x < 27) and (y >= 542) and (y < 559) and (button == 1):
		t = 3
		karamba.deleteMenu(widget, drivemenu)
		getDiskInfo(all)
		drivemenu = karamba.createMenu(widget)
		for i in range(0, len(label)):
			item = karamba.addMenuItem(widget, drivemenu, ("Device: %s @ Mountpoint: %s" % (mountpoint[i], label[i])), 'kdf')
			if item < 0:
				item = item * -1
			selection[item] = i
		karamba.popupMenu(widget, drivemenu, x, y)

# date & time change
	global now
	global thetime
	global thedate
	global h
	if (x >= 30) and (x < 101) and (y >= 568) and (y < 590) and (button == 1) and (h == 1):
		karamba.deleteText(widget, now)
		now = karamba.createText(widget, 16, 574, 140, 22, thedate)
		karamba.changeTextFont(widget, now, 'verdana')
		karamba.changeTextSize(widget, now, 11)
		karamba.changeTextColor(widget, now, 255, 255, 255)
		h = 0
	elif (x >= 30) and (x < 101) and (y >= 568) and (y < 590) and (button == 1):	
			karamba.deleteText(widget, now)
			h = 1


# move widget	
	position = karamba.getWidgetPosition(widget)		 
	if (y >= 600) and (position[1] > -600) and (button == 1):
		i = 0
		g = 0
		while g < 601:
			karamba.moveWidget(widget, xpos, i)
			i = i-5
			g = g+5
		
	if (position[1] == -600) and (button == 1):
		i = -600
		g = 0
		while g < 601:
			karamba.moveWidget(widget, xpos, i)
			i = i+5
			g = g+5
			

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
# highlight icons
	global go ,desktop, desktoptoggle, mech, cpu, netyellow, netgreen, mem, drive, arrow
    	if (x >= 8) and (x < 25) and (y >= 8) and (y < 25):
			karamba.changeImageIntensity(widget, go, 0.3) 
	else:
			karamba.removeImageEffects(widget, go)
    	if (x >= 8) and (x < 25) and (y >= 38) and (y < 55):
			karamba.changeImageIntensity(widget, desktoptoggle, 0.3)
	else:			
			karamba.removeImageEffects(widget, desktoptoggle)
	if (x >= 35) and (x < 52) and (y >= 38) and (y < 55):
			karamba.changeImageIntensity(widget, desktop[1], 0.3)
	else:
			karamba.removeImageEffects(widget, desktop[1])
	if (x >= 65) and (x < 82) and (y >= 38) and (y < 55):
			karamba.changeImageIntensity(widget, desktop[2], 0.3)
	else:			
			karamba.removeImageEffects(widget, desktop[2])
	if (x >= 95) and (x < 112) and (y >= 38) and (y < 55):
			karamba.changeImageIntensity(widget, desktop[3], 0.3)
	else:			
			karamba.removeImageEffects(widget, desktop[3])
	if (x >= 124) and (x < 141) and (y >= 38) and (y < 55):
			karamba.changeImageIntensity(widget, desktop[4], 0.3)
	else:			
			karamba.removeImageEffects(widget, desktop[4])
	if (x >= 8) and (x < 25) and (y >= 78) and (y < 95):
			karamba.changeImageIntensity(widget, mech, 0.3)
	else:			
			karamba.removeImageEffects(widget, mech)		
	if (x >= 8) and (x < 25) and (y >= 128) and (y < 145):
			karamba.changeImageIntensity(widget, cpu, 0.3)
	else:			
			karamba.removeImageEffects(widget, cpu)
	if (x >= 8) and (x < 25) and (y >= 178) and (y < 195):
			karamba.changeImageIntensity(widget, netyellow, 0.3)
	else:			
			karamba.removeImageEffects(widget, netyellow)			
	if (x >= 8) and (x < 25) and (y >= 228) and (y < 245):	
			karamba.changeImageIntensity(widget, netgreen, 0.3)
	else:			
			karamba.removeImageEffects(widget, netgreen)
	if (x >= 8) and (x < 25) and (y >= 283) and (y < 300):	
			karamba.changeImageIntensity(widget, mem, 0.3)
	else:			
			karamba.removeImageEffects(widget, mem)
	if (x >= 8) and (x < 25) and (y >= 340) and (y < 357):
			karamba.changeImageIntensity(widget, drive[0], 0.3)
	else:			
			karamba.removeImageEffects(widget, drive[0])
	if (x >= 8) and (x < 25) and (y >= 400) and (y < 417):
			karamba.changeImageIntensity(widget, drive[1], 0.3)
	else:
			karamba.removeImageEffects(widget, drive[1])
	if (x >= 8) and (x < 25) and (y >= 460) and (y < 477):
			karamba.changeImageIntensity(widget, drive[2], 0.3)
	else:
			karamba.removeImageEffects(widget, drive[2])
	if (x >= 8) and (x < 25) and (y >= 520) and (y < 537):
			karamba.changeImageIntensity(widget, drive[3], 0.3)
	else:
			karamba.removeImageEffects(widget, drive[3])
	if (x >= 10) and (x < 27) and (y >= 362) and (y < 379):
		karamba.changeImageIntensity(widget, arrow[0], 0.3)
	else:
			karamba.removeImageEffects(widget, arrow[0])
	if (x >= 10) and (x < 27) and (y >= 422) and (y < 439):
		karamba.changeImageIntensity(widget, arrow[1], 0.3)
	else:
			karamba.removeImageEffects(widget, arrow[1])
	if (x >= 10) and (x < 27) and (y >= 482) and (y < 499):
		karamba.changeImageIntensity(widget, arrow[2], 0.3)
	else:
			karamba.removeImageEffects(widget, arrow[2])
	if (x >= 10) and (x < 27) and (y >= 542) and (y < 559):
		karamba.changeImageIntensity(widget, arrow[3], 0.3)
	else:
			karamba.removeImageEffects(widget, arrow[3])

def getDiskInfo(all):

	global label
	global m
	global disk
	global drive
	global disktotal
	global diskfree
	global pics
	global k
	global mountpoint
	global total
	global free
	global percent
	label = []
	fs = []
	pics = []
	total = []
	free = []
	percent = []
	mountpoint = []
	k = -1
	m = 0
	f = open ("/etc/mtab","r")
	lines = f.readlines()
	f.close()
	fromdf = commands.getoutput('df -h -a')
	for line in lines:
		k = k+1
		mountpoint.append(string.split(line)[0])
		label.append(string.split(line)[1])
		fs.append(string.split(line)[2])

		dfall = string.split(fromdf,'\n')
		dfsingle = dfall[m + 1]
		fspace = string.split(dfsingle)
		total.append(fspace[1])
		free.append(fspace[3])
		if fspace[4][len(fspace[4]) - 1] in ['%']:
			fspace[4] = fspace[4][:len(fspace[4]) - 1]
		elif fspace[4][len(fspace[4]) - 1] in ['-']:
			fspace[4] = 0
		percent.append(fspace[4])
		m = m + 1

	while k <> -1:
		if (fs[k] == "ext2") or (fs[k] == "ext3") or (fs[k] == "reiserfs"):
			pics.append('pics/hdd_linux_mount.png')
		elif (fs[k] == "vfat") or (fs[k] == "ntfs")  or (fs[k] == "smbfs"):
			pics.append('pics/hdd_win_mount.png')
		elif (fs[k] == "iso9660"):
			pics.append('pics/cdrom_mount.png')
		elif (fs[k] == "udf"):
			pics.append('pics/dvd_mount.png')
		elif (fs[k] == "nfs"):
			pics.append('pics/hdd_nfs_mount.png')
		else:
			pics.append('pics/hdd_unknown_mount.png')
		k = k - 1
	pics.reverse()
	
	return

def menuItemClicked(widget, diskmenu, id):
	global selection
	global which
	global t

	print "id:" + str(id)
	index = id * -1
	print "index:" + str(index)
	print "selection:" + str(selection[index])
	if (t == 0):
		which[0]  = selection[index]
		karamba.writeConfigEntry(widget,"disk0",str(which[0]))
	if (t == 1):
		which[1]  = selection[index]
		karamba.writeConfigEntry(widget,"disk1",str(which[1]))
	if (t == 2):
		which[2]  = selection[index]
		karamba.writeConfigEntry(widget,"disk2",str(which[2]))
	if (t == 3):
		which[3]  = selection[index]
		karamba.writeConfigEntry(widget,"disk3",str(which[3]))
	widgetUpdated(widget)

# This will be printed when the widget loads.
print ""
print "Loaded eyeon.theme python extension."
print "Suggestions welcome to ramone@oxibiose.dyndns.org !"
print ""

