##Begin of Config Section##

url = "barrapunto.com/barrapunto.rdf" #Put your favorite rdf here. You can find a list in RDFS
pic = "pics/barrapunto.png"	# Put your favorite pic here, there are some in pics/
#This will be autodetected in future versions
picw = 332	#Pic width
pich = 66	#Pic height

##End of Config Section##


import karamba
import commands
import string
import os
import glob

iniciando = 0
noticias = []
noticiasy = []
enlaces = []
sombreado = -1
esperando = 0

def RatonSobreNoticia(widget, x, y):

	if (x < 30) or (x > 510): return -1
	global noticias
	global noticiasy
	for i in xrange(len(noticias)):
		if ( y > noticiasy[i] ) and ( y < noticiasy[i]+17):
			return i
	return -1

def CrearImagen(widget):
	global iniciando
	global image
	image = karamba.createImage(widget,103,15,pic)
	pass

def Espere(widget):
	global espere
	global esperando

#This will be implemented in next version
#	global noticias
#	for i in xrange(len(noticias)):
#		karamba.changeText(widget,noticias[i],"")
	espere = karamba.createText(widget, 200, 150, 520, 90, "Fetching News\nPlease Wait")
	karamba.changeTextFont(widget, espere, "Drifft")
	karamba.changeTextColor(widget, espere, 255,255,255)
	karamba.changeTextSize(widget, espere, 10)
	karamba.changeTextShadow(widget, espere, 2)		
	esperando = 1
#	karamba.redrawWidget(widget)
	pass

def NoEspere(widget):
	global espere
	global esperando
	if esperando: karamba.changeText(widget,espere, "")
	esperando = 0
	pass
	
def CreaNoticias(widget):


	global noticias
	global noticiasy

	print "Fetching " + url
	texto = commands.getoutput("rdf.pl " + url)
	print "Finished"
	texto = texto.replace("\r\n","\n")
	lineas = texto.split(os.linesep)

	x = 30
	y = 90
	w = 510
	h = 17
	NoEspere(widget)
	for i in xrange(len(lineas)):
		if (i%2 == 0) and (i > 2) and (len(noticias) < 10):
			noticia = karamba.createText(widget, x, y, w, h, lineas[i])
			karamba.changeTextFont(widget, noticia, "Drifft")
			karamba.changeTextColor(widget, noticia, 255,255,255)
			karamba.changeTextSize(widget, noticia, 10)
			noticias.append(noticia)
			noticiasy.append(y)
			y += 17

		elif (i > 4):
			enlace = lineas[i]
			enlaces.append(enlace)

	karamba.createClickArea(widget, x, 90, w-40, (len(noticias)*17), "")
	karamba.createClickArea(widget, (528-picw)/2, 15, picw, pich, "kstart konqueror "+ lineas[1])

def ActualizaNoticias(widget):
	global iniciando
	global enlaces
	n = 4
	print "Fetching " + url
	texto = commands.getoutput("rdf.pl " + url)
	print "Finished"
	texto = texto.replace("\r\n","\n")
	lineas = texto.split(os.linesep)
	NoEspere(widget)
	for i in xrange(len(noticias)):
		karamba.changeText(widget, noticias[i], lineas[n])
		enlaces.append(lineas[n+1])
		n += 2

	pass


def Iniciar(widget):
	global iniciando
	CreaNoticias(widget)
	iniciando = 2

def initWidget(widget):
	pass

def widgetUpdated(widget):
	print "Updating widget"
	global iniciando
	
	if (iniciando >  3):
		ActualizaNoticias(widget)
	elif (iniciando == 0):
		CrearImagen(widget)
		Espere(widget)
		iniciando = 1
	elif (iniciando == 1):
		Iniciar(widget)
	#SuperKaramba 0.17j updates widget three times at init,
	#we don't want these three updates because they make
	#News Panel init tooooo slow
	elif (iniciando >= 2) and (iniciando <= 3 ) :
		iniciando += 1		
	karamba.redrawWidget(widget)
	print "Updating finished"
	pass

def widgetClicked(widget, x, y, button):
	apuntado = RatonSobreNoticia(widget, x, y)
	if (apuntado >= 0):
		os.system("kstart konqueror "+ enlaces[apuntado])
	pass

def widgetMouseMoved(widget, x, y, button):

#Text shadow: comment following 14 lines if you don't like it
	global noticias
	global sombreado
	apuntado = RatonSobreNoticia(widget, x, y)
	if ( apuntado >= 0 and sombreado != apuntado):
		karamba.changeTextShadow(widget,noticias[apuntado],3)
		sombreado = apuntado
		for i in xrange(len(noticias)):
			if ( i != apuntado):
				karamba.changeTextShadow(widget,noticias[i],0)
		karamba.redrawWidget(widget)
	elif (apuntado == -1) and (sombreado != -1):
		karamba.changeTextShadow(widget,noticias[sombreado],0)
		sombreado = -1
		karamba.redrawWidget(widget)
#End of text shadow

	pass

print "Loaded my python extension!"

