# CONFIGURATION VARIABLES
global rssfeed, caption, captioncolor, titlecolor, descriptioncolor
# URL of the RSS feed
rssfeed = "http://www.newsforge.com/reports.rss"
# Label of the newsticker
caption = "Linux news from NewsForge"
# Color of the label above
captioncolor = "white"
# Color of the title
titlecolor = "navy"
# COlor of the description
descriptioncolor = "blue"


#this import statement allows access to the karamba functions
import karamba
import rssparser

def managerss():
    global news
    news = rssparser.parse( rssfeed )


def managenews(headline):
    global content
    content = "<b><font size=2 color=\""+captioncolor+"\">"+caption+"</font></b><br><font size=3 color=\""+titlecolor+"\">"
    content = content+"<b><a href=\"konqueror "+news['items'][headline]['link']+"\">"+news['items'][headline]['title']+"</a></b><br></font><font size=2 color=\""+descriptioncolor+"\">"
    content = content+news['items'][headline]['description']+"<br>"
    content = content+"</font>"


global currentnewsf
currentnewsf = "/tmp/.skrssreader"

#this is called when you widget is initialized
def initWidget(widget):
		managerss()
		managenews(0)
		global feed
		feed = karamba.createRichText(widget, content, 1)
		karamba.setRichTextWidth(widget, feed, 300)
		karamba.redrawWidget(widget)
		currentnews = open( currentnewsf, "w")
		currentnews.write("1")
		currentnews.close()


#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
		newsnum = 10
		if newsnum > len(news['items']) :
			newsnum = len(news['items'])
		
		currentnews = open( currentnewsf, "r+" )
		notiziaid = int( currentnews.readline() )
		currentnews.close()
		if notiziaid >= newsnum :
			currentnewsnum = 0
		else:
			currentnewsnum = notiziaid + 1

		currentnews = open( currentnewsf, "w" )
		currentnews.write( str( currentnewsnum ) )
		currentnews.close()
		managenews( notiziaid )
		karamba.changeRichText(widget, feed, content)
		karamba.redrawWidget(widget)

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
#def widgetClicked(widget, x, y, button):
#	pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
	pass

# This will be printed when the widget loads.
print "Enjoy Flavio Gargiulo's RSS reader for SuperKaramba!!!! Extensions loaded ;)"
