# t-bar by Tschaeck (tschaeck@t-racing.de) 2003
#this import statement allows access to the karamba functions
import karamba
down = 0
#this is called when you widget is initialized
def initWidget(widget):
	global imgdown, imgup
	karamba.moveWidget(widget,190,-81)
	imgdown = karamba.createImage(widget,160,120,"images/down.png")
	imgup = karamba.createImage(widget,160,120,"images/up.png")
	karamba.hideImage(widget,imgup)

#this is called everytime your widget is updated
#the update inverval is specified in the .theme filed
def widgetUpdated(widget):
	pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	global down, imgdown, imgup

	up=1
	if y>116:
		if down == 0:
			for i in range(-81,39,4):
				karamba.moveWidget(widget,190,i)
				karamba.hideImage(widget,imgdown)
				karamba.showImage(widget,imgup)
				down = 1
				up = 0
		if (down == 1) and (up == 1):
			for i in range(35,-85,-4):
				karamba.moveWidget(widget,190,i)
				karamba.hideImage(widget,imgup)
				karamba.showImage(widget,imgdown)
				down = 0

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
	pass


def meterClicked(widget, meter, button):
	pass

