# t-bar by Tschaeck (tschaeck@t-racing.de) 2003
#this import statement allows access to the karamba functions
import karamba
import os
import array
import math

#global def of the arrays. i think 30 entries should be enough
images=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
tiles      =[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
pagerback      =[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
pager      =[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
text      =[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
imageFiles = ["","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""]
imageCmd = ["","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""]
imageCordsX=[10,352,930,"","","","","","","","","","","","","","","","","","","","","","","","","","",""]
imageCordsY=[0,5,5,"","","","","","","","","","","","","","","","","","","","","","","","","","",""]
widthheight = [32,22,22,"","","","","","","","","","","","","","","","","","","","","","","","","","",""]

init=0
change = -1
config = 0

# Ok read the users kdeglobals file and find out just how many desktops they have.
# Right now I'm assuming that the .kde file exists as I flesh this out I'll test for
# more possible combos.
f=file(os.path.expanduser('~/.kde/share/config/kdeglobals'))
All_Words=f.readlines()
for i in range(len(All_Words)):
        Words=All_Words.pop().split('=')
	Words.reverse()
	if Words.pop() == "Number":
		desktops = Words.pop()
		# change the desktops varible into an integer.
		desktops = int(desktops)

#this is called when you widget is initialized
def initWidget(widget):
	pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme filed
def widgetUpdated(widget):
	global images, imageFiles, imageCordsX, imageCordsY, imageCmd, widthheight, init, config, imagecount, spacing, config

	if init == 0:
		#Configuration
		karamba.addMenuConfigOption(widget, "addicon", "Add new Icon")
		karamba.setMenuConfigOption(widget, "addicon", "0")

		karamba.addMenuConfigOption(widget, "delicon", "Delete Icon")
		karamba.setMenuConfigOption(widget, "delicon", "0")

		karamba.addMenuConfigOption(widget, "setspacing", "Spacing between Icons")
		karamba.setMenuConfigOption(widget, "setspacing", "0")

		karamba.addMenuConfigOption(widget, "pager", "Display Pager")
		karamba.setMenuConfigOption(widget, "pager", "1")

		#the very first time configuration setup
		version = karamba.readConfigEntry(widget, "version")
		if version == None:
			karamba.writeConfigEntry(widget, "version", "0.1")
			karamba.writeConfigEntry(widget, "setspacing", "9")

			karamba.writeConfigEntry(widget, "imageFiles0", "images/kde.png")
			karamba.writeConfigEntry(widget, "imageFiles1", "images/exit.png")
			karamba.writeConfigEntry(widget, "imageFiles2", "images/clock.png")
			karamba.writeConfigEntry(widget, "imageFiles3", "images/konqueror.png")
			karamba.writeConfigEntry(widget, "imageFiles4", "images/kmail.png")
			karamba.writeConfigEntry(widget, "imageFiles5", "images/licq.png")
			karamba.writeConfigEntry(widget, "imageFiles6", "images/seperator.png")
			karamba.writeConfigEntry(widget, "imageFiles7", "images/gimp.png")
			karamba.writeConfigEntry(widget, "imageFiles8", "images/quanta.png")

			karamba.writeConfigEntry(widget, "imageCmd0", "dcop kicker kicker popupKMenu 0,31")
			karamba.writeConfigEntry(widget, "imageCmd1", "dcop kdesktop KDesktopIface logout")
			karamba.writeConfigEntry(widget, "imageCmd2", "")
			karamba.writeConfigEntry(widget, "imageCmd3", "kfmclient openProfile webbrowsing")
			karamba.writeConfigEntry(widget, "imageCmd4", "kmail")
			karamba.writeConfigEntry(widget, "imageCmd5", "licq")
			karamba.writeConfigEntry(widget, "imageCmd6", "")
			karamba.writeConfigEntry(widget, "imageCmd7", "gimp")
			karamba.writeConfigEntry(widget, "imageCmd8", "quanta")

			karamba.writeConfigEntry(widget, "imagecount", "9")


		#Read Configuration
		spacing = karamba.readConfigEntry(widget, "setspacing")
		imagecount = karamba.readConfigEntry(widget, "imagecount")
		for i in range (30):
			imageFiles[i] = karamba.readConfigEntry(widget, "imageFiles" + str(i))
			imageCmd[i] = karamba.readConfigEntry(widget, "imageCmd" + str(i))

		#Create Toolbar
		for i in range(imagecount):
			if (imageCordsX[i] == "") and  (imageCordsY[i] == ""):
				if imageFiles[i] == "images/seperator.png":
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 59
					imageCordsY[i] = 10
				else:
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 55
					imageCordsY[i] = 8
					widthheight[i] = 16
			images[i] = karamba.createImage(widget,imageCordsX[i],imageCordsY[i],imageFiles[i])
			if widthheight[i] == 16:
				tiles[i] = karamba.createImage(widget,imageCordsX[i]-2,imageCordsY[i]-2,"images/tile.png")
				karamba.hideImage(widget,tiles[i])
			if imageFiles[i] != "images/seperator.png":
				karamba.attachClickArea(widget,images[i],imageCmd[i],"","")
			karamba.redrawWidget(widget)

	if (init == 0) or (config == 2):
  #Create Pager
		if ( (karamba.readConfigEntry(widget,"pager") == None) or (karamba.readConfigEntry(widget,"pager") == 1)):
			for i in range (int( math.ceil(float(desktops) / 2))):
				desktopx = 290-(i*29)
				pagerback[i] = karamba.createImage(widget,desktopx,0,"images/pager.png")

			j=0
			xcords = desktopx+31
			ycords = 0
			for i in range(desktops):
				if (i == int( math.ceil(float(desktops) / 2))):
					j=0
					xcords = desktopx+18
					ycords = 13
				pager[i] = karamba.createImage(widget,xcords+(j*(20+desktops)),ycords,"images/background.png")
				text[i] = karamba.createText(widget,xcords+(j*(20+desktops))+3,ycords,12,12,str(i+1))
				karamba.changeTextColor(widget, text[i], 255,255,255)
				karamba.changeTextShadow(widget, text[i], 1)
				karamba.attachClickArea(widget,pager[i],"dcop kwin KWinInterface setCurrentDesktop "+ str(i+1),"","")
				j = j+1
			karamba.redrawWidget(widget)
		init = 1
		config = 0

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
	pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
	global images, tiles, imageFiles, imageCordsX, imageCordsY, imageCmd, change, widthheight

	for i in range(imagecount):
		if imageFiles[i] != "images/seperator.png":
			if (x >= imageCordsX[i]) and (x <= (imageCordsX[i] + widthheight[i])) and (y >= imageCordsY[i]) and (y <= (imageCordsY[i] + widthheight[i])) and (change == -1):
				if widthheight[i] == 16:
					karamba.showImage(widget,tiles[i])
					karamba.redrawWidget(widget)
				else:
					for j in range(10):
						karamba.changeImageIntensity(widget, images[i], (j*0.04), 0)
						karamba.redrawWidget(widget)
				change = i

	if (change !=-1 ) and ((x < imageCordsX[change]) or (x > (imageCordsX[change] + widthheight[change])) or (y < imageCordsY[change]) or (y > (imageCordsY[change] + widthheight[change]))):
		if widthheight[change] == 16:
			karamba.hideImage(widget,tiles[change])
			karamba.redrawWidget(widget)
		else:
			for j in range(10):
				karamba.changeImageIntensity(widget, images[change], ((10 - j) *0.04), 0)
				karamba.redrawWidget(widget)
		change = -1



def menuOptionChanged(widget, key, value):
	global imagecount, spacing, imageFiles, imageCmd, imageCordsX, imageCordsY, widthheight, images, tiles, config
	pagerconf = 0

#Spacing between the buttons
	if key == "setspacing":
		karamba.setMenuConfigOption(widget, "setspacing", "0")
		pipe = os.popen("kdialog --title \"Set Spacing\" --inputbox \"Please enter a number >= 4 to set the spacing between the buttons: \n(default=9)\"", 'r')
		rawarea = pipe.readlines()
		spacing = rawarea[0].strip()
		if int(spacing) >= 1:
			karamba.writeConfigEntry(widget, "setspacing", spacing)

			spacing = int(spacing)
			for i in range(3,imagecount):
				if imageFiles[i] == "images/seperator.png":
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 59
					imageCordsY[i] = 10
				else:
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 55
					imageCordsY[i] = 8
					widthheight[i] = 16
				karamba.moveImage(widget,images[i],imageCordsX[i],imageCordsY[i])
				if widthheight[i] == 16:
					karamba.moveImage(widget,tiles[i],imageCordsX[i]-2,imageCordsY[i]-2)
				if imageFiles[i] != "images/seperator.png":
					karamba.attachClickArea(widget,images[i],imageCmd[i],"","")
				karamba.redrawWidget(widget)

#add new icon
	if key == "addicon":
		karamba.setMenuConfigOption(widget, "addicon", "0")
		pipe = os.popen("kdialog --title \"Add new Icon\" --inputbox \"Please enter the path to your 16x16 icon: \ne.g.: images/kmail.png, /opt/kde3/share/icons/crystal/16x16/apps/kmail.png\"", 'r')
		rawarea = pipe.readlines()
		imagepath = rawarea[0].strip()

		pipe = os.popen("kdialog --title \"Add new Icon\" --inputbox \"Please enter the command which is executed when clicking on the icon: \ne.g.: kmail\"", 'r')
		rawarea = pipe.readlines()
		command = rawarea[0].strip()

		pipe = os.popen("kdialog --title \"Add new Icon\" --inputbox \"Please enter the number of position of your icon: \n1 = first icon after the KDE-Icon; max = " +str(imagecount-2)+ ". Do also count the seperators\"", 'r')
		rawarea = pipe.readlines()
		position = rawarea[0].strip()

		position = int(position) + 2
		if (position >= 3) and (position <= imagecount) and (imagepath != ""):
			imageFiles.insert(position,imagepath)
			imageCmd.insert(position,command)
			imagecount = imagecount + 1

			karamba.writeConfigEntry(widget, "imagecount", str(imagecount))
			for i in range(3,imagecount):
				karamba.writeConfigEntry(widget, "imageFiles"+str(i), imageFiles[i])
				karamba.writeConfigEntry(widget, "imageCmd"+str(i), imageCmd[i])

			#rearrange icons
			for i in range (position,imagecount):
				if imageFiles[i] == "images/seperator.png":
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 59
					imageCordsY[i] = 10
					widthheight[i] = ""
				else:
					imageCordsX[i] = ((i - 3)*(16 + spacing)) + 55
					imageCordsY[i] = 8
					widthheight[i] = 16


			images.insert(position,karamba.createImage(widget,imageCordsX[position],imageCordsY[position],imageFiles[position]))
			if imageFiles[position] != "images/seperator.png":
				karamba.attachClickArea(widget,images[position],imageCmd[position],"","")
				tiles.insert(position,karamba.createImage(widget,imageCordsX[position]-2,imageCordsY[position]-2,"images/tile.png"))
				karamba.hideImage(widget,tiles[position])
			else:
				tiles.insert(position,"")

			for i in range((position+1),imagecount):
				karamba.moveImage(widget,images[i],imageCordsX[i],imageCordsY[i])
				if widthheight[i] == 16:
					karamba.attachClickArea(widget,images[i],imageCmd[i],"","")
					karamba.moveImage(widget,tiles[i],imageCordsX[i]-2,imageCordsY[i]-2)


#Delete icon
	if key == "delicon":
		karamba.setMenuConfigOption(widget, "delicon", "0")
		checklist = ""
		for i in range(3,imagecount):
			checklist = checklist + " "+str(i)+ " "+ str(imageFiles[i])+" 0 "
		pipe = os.popen("kdialog --title \"Delete Icon\" --checklist \"Please select the icons you want to delete:\" "+checklist+"", 'r')
		rawarea = pipe.readlines()
		#reading the icons that have to be deleted. a bit too circumstantially, but i didn't find another way to do this
		rawarea[0] = str.replace(rawarea[0],"\""," ")
		rawarea[0] = str.replace(rawarea[0],"   ","\" \"")
		rawarea[0] = str.replace(rawarea[0],"  \n","")
		delicon = rawarea[0].strip()
		count = str.count(delicon,"\" \"")+1
		delicon = str.split(delicon,"\" \"")

		for i in range(0,count):
			#delete array keys
			imagecount = (imagecount - 1)
			imageFiles.pop(int(delicon[i]))
			imageCmd.pop(int(delicon[i]))

			karamba.deleteImage(widget,images[int(delicon[i])])
			karamba.deleteImage(widget,tiles[int(delicon[i])])

			images.pop(int(delicon[i]))
			tiles.pop(int(delicon[i]))

		karamba.writeConfigEntry(widget, "imagecount", str(imagecount))
		for i in range(3,imagecount):
			karamba.writeConfigEntry(widget, "imageFiles"+str(i), imageFiles[i])
			karamba.writeConfigEntry(widget, "imageCmd"+str(i), imageCmd[i])


		#rearrange icons
		position = int(delicon[0])
		for i in range(position,imagecount):
			if imageFiles[i] == "images/seperator.png":
				imageCordsX[i] = ((i - 3)*(16 + spacing)) + 59
				imageCordsY[i] = 10
				widthheight[i] = ""
			else:
				imageCordsX[i] = ((i - 3)*(16 + spacing)) + 55
				imageCordsY[i] = 8
				widthheight[i] = 16

			karamba.moveImage(widget,images[i],imageCordsX[i],imageCordsY[i])
			if widthheight[i] == 16:
				karamba.moveImage(widget,tiles[i],imageCordsX[i]-2,imageCordsY[i]-2)
				#karamba.attachClickArea(widget,images[i],imageCmd[i],"","")

#Display / Hide Pager
	if key == "pager":
		karamba.setMenuConfigOption(widget, "pager", "0")
		#hide pager
		if (karamba.readConfigEntry(widget, "pager") == 1):
			karamba.writeConfigEntry(widget,"pager","0")
			for i in range(30):
				karamba.deleteImage(widget,pager[i])
				karamba.deleteImage(widget,pagerback[i])
				karamba.deleteText(widget,text[i])
			karamba.redrawWidget(widget)
			pagerconf = 1
		#show
		if (karamba.readConfigEntry(widget, "pager") == 0) and (pagerconf == 0):
			karamba.writeConfigEntry(widget,"pager","1")
			config = 2


def meterClicked(widget, meter, button):
	pass

